#line 1 "arpservice.c"
























 


#line 1 "arpservice.h"
























 




#line 1 "emacdriver.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 31 "arpservice.h"
#line 1 "ipservice.h"
























 





#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 32 "arpservice.h"

extern PtrARPTableElementRecT LocateMACForIP ( PtrIPLayerInstanceRecT   ,
                                               ULONG                    ) ;

extern void ProcessARPPacked ( PtrIPLayerInstanceRecT   ,
                               PtrOSFrameRecT           ) ;

extern void PrepareARPRequest ( PtrIPLayerInstanceRecT   ,
                                ULONG                    ) ;

extern void DiagARPTable ( PtrIPLayerInstanceRecT   ) ;

extern void DelARPTableElement ( PtrIPLayerInstanceRecT   ,
                                 ULONG                    ) ;

extern void DelARPTable ( PtrIPLayerInstanceRecT   ) ;

#line 29 "arpservice.c"
#line 30 "arpservice.c"
#line 31 "arpservice.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 32 "arpservice.c"









typedef struct {
                 USHORT               HardwareType ;                            
                 USHORT               ProtocolType ;                            
                 USHORT               AddressLength ;                           
                 USHORT               Operation ;                               
                 UCHAR                SenderMACAddress [ 6 ] ;  
                 ULONG                SenderIPAddress ;                         
                 UCHAR                TargetMACAddress [ 6 ] ;  
                 ULONG                TargetIPAddress ;                         
               } ARPHeaderRecT ;                                                
#line 60 "arpservice.c"



static UCHAR Broadcast [ 6 ] = { 0xFF , 0xFF , 0xFF , 0xFF , 0xFF , 0xFF } ;










 


PtrARPTableElementRecT LocateMACForIP ( PtrIPLayerInstanceRecT IPLayerInstance ,
                                        ULONG                  IPAddress )
{
  ULONG Loop ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( IPLayerInstance -> ARPTable [ Loop ] . ValidElement )
    {
      if ( IPLayerInstance -> ARPTable [ Loop ] . IPAddress == IPAddress )
      {
        IPLayerInstance -> ARPTable [ Loop ] . LifeTime = 1280 ;
        return ( & ( IPLayerInstance -> ARPTable [ Loop ] ) ) ;
      }   ;
    }   ;
  }   ;
  return ( void * ) 0 ;
}  


static void AddARPTabElement ( PtrIPLayerInstanceRecT IPLayerInstance ,
                               UCHAR *                MACAddress ,
                               ULONG                  IPAddress )
{
  ULONG Loop ;
  ULONG MinPos ;
  UCHAR * OCh ;
  UCHAR * ICh ;
  PtrARPTableElementRecT TabElement ;
  USHORT MinValue ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( IPLayerInstance -> ARPTable [ Loop ] . ValidElement )
    {
      if ( IPLayerInstance -> ARPTable [ Loop ] . IPAddress == IPAddress )
      {
        return ;
      }   ;
    }   ;
  }   ;
  TabElement = ( void * ) 0 ;
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( ! IPLayerInstance -> ARPTable [ Loop ] . ValidElement )
    {
      TabElement = & ( IPLayerInstance -> ARPTable [ Loop ] ) ;
      break ;
    }   ;
  }   ;
  if ( ! TabElement )
  {
    MinValue = IPLayerInstance -> ARPTable [ 0 ] . LifeTime ;
    MinPos = 0 ;
    for ( Loop = 1 ; Loop < 8 ; Loop ++ )
    {
      if ( IPLayerInstance -> ARPTable [ Loop ] . LifeTime < MinValue )
      {
        MinValue = IPLayerInstance -> ARPTable [ Loop ] . LifeTime ;
        MinPos = Loop ;
      }   ;
    }   ;
    IPLayerInstance -> ARPTable [ MinPos ] . ValidElement = 0 ;
    TabElement = & ( IPLayerInstance -> ARPTable [ MinPos ] ) ;
  }   ;
  OCh = TabElement -> MACAddress ;
  ICh = MACAddress ;
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
    * OCh ++ = * ICh++ ;
  TabElement -> ValidElement = 1 ;
  TabElement -> LifeTime = 1280 ;
  TabElement -> IPAddress = IPAddress ;
}  


static void SendARPResponse ( PtrIPLayerInstanceRecT IPLayerInstance ,
                              ARPHeaderRecT *        ARPPacked )
{
  EMACInstanceRecT * InterfInstance ;
  PtrOSFrameRecT OutFrame ;
   
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( OutFrame )
  {
    OutFrame -> Index = 0 ;
    StartEthFrame ( OutFrame , ARPPacked -> SenderMACAddress , InterfInstance -> InterfaceMACAddress ,
                    0x0806 ) ;
    AddUSHORTSwapField ( OutFrame , 1 ) ;
    AddUSHORTSwapField ( OutFrame , 0x0800 ) ;
    AddUSHORTSwapField ( OutFrame , 0x0604 ) ;
    AddUSHORTSwapField ( OutFrame , 2 ) ;
    AddByteArrayField ( OutFrame , InterfInstance -> InterfaceMACAddress , 6 ) ;
    AddULONGSwapField ( OutFrame , IPLayerInstance -> MyLocalIPAddress ) ;
    AddByteArrayField ( OutFrame , ARPPacked -> SenderMACAddress , 6 ) ;
    AddULONGSwapField ( OutFrame , ARPPacked -> SenderIPAddress ) ;
    InterfInstance -> InterfaceSendFrame ( OutFrame ) ;
    InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  }   ;
}  


static void RecvARPResponse ( PtrIPLayerInstanceRecT IPLayerInstance ,
                              ARPHeaderRecT *        ARPPacked )
{
   
  AddARPTabElement ( IPLayerInstance , ARPPacked -> SenderMACAddress ,
                     ARPPacked -> SenderIPAddress ) ;
}  


void PrepareARPRequest ( PtrIPLayerInstanceRecT IPLayerInstance ,
                         ULONG                  DestIPAddress )
{
  EMACInstanceRecT * InterfInstance ;
  PtrOSFrameRecT OutFrame ;
  UCHAR DestMACAddress [ 6 ] ;
  ULONG Loop ;
   
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( OutFrame )
  {
    OutFrame -> Index = 0 ;
    for ( Loop = 0 ; Loop < 6 ; Loop ++ )
      DestMACAddress [ Loop ] = 0 ;
    StartEthFrame ( OutFrame , Broadcast , InterfInstance -> InterfaceMACAddress ,
                    0x0806 ) ;
    AddUSHORTSwapField ( OutFrame , 1 ) ;
    AddUSHORTSwapField ( OutFrame , 0x0800 ) ;
    AddUSHORTSwapField ( OutFrame , 0x0604 ) ;
    AddUSHORTSwapField ( OutFrame , 1 ) ;
    AddByteArrayField ( OutFrame , InterfInstance -> InterfaceMACAddress , 6 ) ;
    AddULONGSwapField ( OutFrame , IPLayerInstance -> MyLocalIPAddress ) ;
    AddByteArrayField ( OutFrame , DestMACAddress , 6 ) ;
    AddULONGSwapField ( OutFrame , DestIPAddress ) ;
    InterfInstance -> InterfaceSendFrame ( OutFrame ) ;
    InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  }   ;
}  


void ProcessARPPacked ( PtrIPLayerInstanceRecT IPLayerInstance ,
                        PtrOSFrameRecT         Frame )
{
  ARPHeaderRecT ARPPacked ;
   
  ARPPacked . HardwareType = GetUSHORTSwapField ( Frame , 14 + 0 ) ;
  ARPPacked . ProtocolType = GetUSHORTSwapField ( Frame , 14 + 0 + 2 ) ;
  ARPPacked . AddressLength = GetUSHORTSwapField ( Frame , 14 + 0 + 2 + 2 ) ;
  ARPPacked . Operation = GetUSHORTSwapField ( Frame , 14 + 0 + 2 + 2 + 2 ) ;
  GetByteArrayField ( ARPPacked . SenderMACAddress , Frame , 14 + 0 + 2 + 2 + 2 + 2 ,
                      6 ) ;
  ARPPacked . SenderIPAddress = GetULONGSwapField ( Frame , 14 + 0 + 2 + 2 + 2 + 2 + 6 ) ;
  GetByteArrayField ( ARPPacked . TargetMACAddress , Frame , 14 + 0 + 2 + 2 + 2 + 2 + 6 + 4 ,
                      6 ) ;
  ARPPacked . TargetIPAddress = GetULONGSwapField ( Frame , 14 + 0 + 2 + 2 + 2 + 2 + 6 + 4 + 6 ) ;
  if ( ARPPacked . HardwareType == 1 ) 
  {
    if ( ARPPacked . ProtocolType == 0x0800 )
    {
      if ( ARPPacked . AddressLength == 0x0604 )
      {
        switch ( ARPPacked . Operation )
        {
          case 1              :
            if ( ARPPacked . TargetIPAddress == IPLayerInstance -> MyLocalIPAddress )
            {
              SendARPResponse ( IPLayerInstance , & ARPPacked ) ;
            }   ;
            break ;
          case 2             :
            RecvARPResponse ( IPLayerInstance , & ARPPacked ) ;
            break ;
          case 3             :
            break ;
          case 4            :
            break ;
          default                       :
            break ;
        }   ;
      }   ;
    }   ;
  }   ;
}  


void DiagARPTable ( PtrIPLayerInstanceRecT IPLayerInstance )
{
  ULONG Loop ;
  USHORT LifeT ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( IPLayerInstance -> ARPTable [ Loop ] . ValidElement )
    {
      LifeT = IPLayerInstance -> ARPTable [ Loop ] . LifeTime -- ;
      if ( ! LifeT )
      {
        IPLayerInstance -> ARPTable [ Loop ] . ValidElement = 0 ;
      }   ;
    }   ;
  }   ;
}  


void DelARPTableElement ( PtrIPLayerInstanceRecT IPLayerInstance ,
                          ULONG                  IPAddress )
{
  ULONG Loop ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( IPLayerInstance -> ARPTable [ Loop ] . ValidElement )
    {
      if ( IPLayerInstance -> ARPTable [ Loop ] . IPAddress == IPAddress )
      {
        IPLayerInstance -> ARPTable [ Loop ] . ValidElement = 0 ;
        return ;
      }   ;
    }   ;
  }   ;
}  


void DelARPTable ( PtrIPLayerInstanceRecT IPLayerInstance )
{
  ULONG Loop ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    IPLayerInstance -> ARPTable [ Loop ] . ValidElement = 0 ;
  }   ;
}  

