#line 1 "dataservice.c"
























 

#line 1 "dataservice.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "dataservice.h"



typedef UCHAR DataValueType [ 8 ] ;


extern DataValueType Analog1Value ;
extern DataValueType Analog2Value ;
extern DataValueType Analog3Value ;
extern DataValueType Analog4Value ;
extern DataValueType Analog5Value ;
extern DataValueType Analog6Value ;
extern UCHAR On0Status ;
extern UCHAR On1Status ;
extern UCHAR On2Status ;
extern UCHAR On3Status ;

extern void Device01On ( void ) ;

extern void Device01Off ( void ) ;

extern void Device02On ( void ) ;

extern void Device02Off ( void ) ;

extern void SerialPool ( void ) ;

extern void InitDataService ( void ) ;

#line 28 "dataservice.c"
#line 29 "dataservice.c"
#line 1 "uart1.h"























 




#line 30 "uart1.h"

extern UCHAR UART1TxdLEDDelayCounter ;
extern UCHAR UART1RxDLEDDelayCounter ;

extern void UART1InitEnvir ( void ) ;

extern void UART1HardwInit( ULONG   ,
                            UCHAR   ,
                            ULONG   ) ;

extern void UART1InputReset ( void ) ;

extern void UART1Send ( UCHAR   ) ;

extern void UART1SendString ( UCHAR *   ) ;

extern ULONG UART1DataPresent ( void ) ;

extern UCHAR UART1GetData ( void ) ;

extern UCHAR UART1Working ( void ) ;

#line 30 "dataservice.c"
#line 1 "strings.h"
























 




#line 31 "strings.h"


extern void memclear ( void *   ,
                       USHORT   ) ;

extern void memcopy ( void *   ,
                      void *   ,
                      USHORT   ) ;

extern UCHAR Cap ( UCHAR   ) ;

extern void StrCpy ( UCHAR *   ,
               const UCHAR *   ) ;

extern USHORT StrLen ( UCHAR *   ) ;

extern void StrDelete ( UCHAR *   ,
                        USHORT    ,
                        USHORT    ) ;

extern void StrNorm ( UCHAR *   ) ;

extern void StrExp ( USHORT    ,
                     UCHAR *   ) ;

extern void AppendCh ( UCHAR *   ,
                       UCHAR     ) ;

extern void AppendStr ( UCHAR *   ,
                  const UCHAR *   ) ;

extern void Append ( USHORT    ,
                     UCHAR *   ,
               const UCHAR *   ) ;

extern UCHAR * BegOfString ( UCHAR *   ) ;

extern void WordToHexStr ( UCHAR *   ,
                           USHORT    ,
                           UCHAR     ,
                           USHORT    ) ;

extern void WordToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        USHORT    ) ;

extern void LongToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        ULONG     ) ;

extern void IPToString ( UCHAR *   ,
                         ULONG     ) ;

extern UCHAR Digit ( UCHAR   ) ;

extern UCHAR StrToCard ( UCHAR *    ,
                         USHORT *   ) ;

extern UCHAR StrToLCard ( UCHAR *   ,
                          ULONG *   ) ;

extern UCHAR CompareString ( UCHAR *   ,
                             UCHAR *   ,
                             USHORT    ) ;

extern UCHAR StrToIP ( UCHAR *   ,
                       ULONG *   ) ;

#line 31 "dataservice.c"
#line 1 "systime.h"
























 




#line 31 "systime.h"

typedef void ( * TimeServiceProcT ) ( void *   ) ;

typedef struct {
                 ULONG             BellTime ;
                 void *            CallParam ;
                 TimeServiceProcT  CallService ;
               } TimeQueueRecT ;
typedef TimeQueueRecT * PtrTimeQueueRecT ;


extern void SysTimeEnevtService ( void ) ;

extern PtrTimeQueueRecT AttachTimer ( ULONG               ,
                                      TimeServiceProcT    ,
                                      void *              ) ;

extern void DetachTimer ( PtrTimeQueueRecT   ) ;

void SysTimerPool ( void ) ;

void InitSysTime ( void ) ;

#line 32 "dataservice.c"
#line 1 "leddisplay.h"
























 



#line 31 "leddisplay.h"

typedef enum { StatusLED       ,
               UART0TxDLED     ,
               UART0RxDLED     ,
               UART1TxDLED     ,
               UART1RxDLED     ,
               HTTPConnectLED  ,
               DataErrorLED    } LEDSymbolType ;

extern void LEDOn ( LEDSymbolType   ) ;
               
extern void LEDOff ( LEDSymbolType   ) ;

extern void InitLEDEnvir ( void ) ;

#line 33 "dataservice.c"



DataValueType Analog1Value ;            
DataValueType Analog2Value ;            
DataValueType Analog3Value ;            
DataValueType Analog4Value ;            
DataValueType Analog5Value ;            
DataValueType Analog6Value ;            
UCHAR On0Status ;
UCHAR On1Status ;
UCHAR On2Status ;
UCHAR On3Status ;
static USHORT CommandIndex ;
static UCHAR CommandBuffer [ 32 + 1 ] ;

const static UCHAR MyDeviceID [ ]    = "WEBS01" ;

const static UCHAR OnState [ ]       = "CHISON" ;
const static UCHAR OffState [ ]      = "CHISOF" ;

const static UCHAR Device00ID [ ]    = "COSEN1" ;

const static UCHAR Device01ID [ ]    = "PWC001" ;
const static UCHAR Device02ID [ ]    = "PWC002" ;
const static UCHAR Device03ID [ ]    = "MCTRL01" ;

const static UCHAR Device11ID [ ]    = "TMPS01" ;
const static UCHAR Device12ID [ ]    = "TMPS02" ;
const static UCHAR Device13ID [ ]    = "TMPS03" ;
const static UCHAR Device14ID [ ]    = "TMPS04" ;
const static UCHAR Device15ID [ ]    = "TMPS05" ;
const static UCHAR Device16ID [ ]    = "TMPS06" ;

const static UCHAR ChOnCommand [ ]   = "CHON" ;
const static UCHAR ChOffCommand [ ]  = "CHOFF" ;


static void DataErrorLEDOff ( void * CallParam )
{
   
  LEDOff ( DataErrorLED ) ;
}  


static void DataError ( void )
{
   
  AttachTimer ( ( ULONG ) 200 , DataErrorLEDOff , ( void * ) 0 ) ;
  LEDOn ( DataErrorLED ) ;
}   ;


static void UART1SendConstString ( const UCHAR * String )
{
  const UCHAR * ChPtr ;
  UCHAR Ch ;
   
  ChPtr = String ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
      break ;
    UART1Send ( Ch ) ;
  }   ;
}  


static USHORT CompStr ( UCHAR *       String ,
                        const UCHAR * Pattern )
{
  UCHAR Ch1 ;
  UCHAR Ch2 ;
  USHORT Loop ;
   
  for ( Loop = 0 ; Loop < CommandIndex ; Loop ++ )
  {
    Ch1 = String [ Loop ] ;
    Ch2 = Pattern [ Loop ] ;
    if ( Ch1 != Ch2 )
      return 0 ;
    if ( ! Ch1 )
      return 1 ;
  }   ;
  return 0 ;
}  


static UCHAR SetNewState ( UCHAR * Command )
{
   
  if ( CompStr ( Command , OnState ) )
    return 1 ;
  if ( CompStr ( Command , OffState ) )
    return 0 ;
  return 0 ;
}  


static void SetValue ( UCHAR * OutValue ,
                       UCHAR * Command )
{
  UCHAR * ChPtr ;
  UCHAR Ch ;
  USHORT Loop ;
   
  ChPtr = Command ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
      return ;
    if ( Ch == '.' )
      break ;
  }   ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
      return ;
    if ( Ch == '.' )
      break ;
  }   ;
  for ( Loop = 0 ; Loop < sizeof ( DataValueType ) ; Loop ++ )
  {
    Ch = * ChPtr ++ ;
    if ( ( ! Ch ) || ( Ch == '.' ) )
    {
      * OutValue ++ = 0 ;
      return ;
    }   ;
    * OutValue ++ = Ch ;
  }   ;
}  


static void ExecuteSerialCommand ( void )
{

  USHORT Index ;
  UCHAR Ch ;
  UCHAR * ChPtr ;
  UCHAR DeviceID [ 8 ] ;
  UCHAR Command [ 32 ] ;
   
  Index = 0 ;
  ChPtr = CommandBuffer ;
  memclear ( DeviceID , sizeof ( DeviceID ) ) ;
  memclear ( Command , sizeof ( Command ) ) ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
    {
      DataError ( ) ;
      return ;
    }   ;
    if ( Ch == ':' )
      break ;
  }   ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
    {
      DataError ( ) ;
      return ;
    }   ;
    if ( Ch == ':' )
      break ;
    if ( Index < sizeof ( DeviceID ) )
      DeviceID [ Index ] = Ch ;
    Index ++ ;
  }   ;
  Index = 0 ;
  for ( ; ; )
  {
    Ch = * ChPtr ++ ;
    if ( ! Ch )
      break ;
    if ( Index < sizeof ( Command ) )
      Command [ Index ] = Ch ;
    Index ++ ;
  }   ;
  if ( CompStr ( DeviceID , Device00ID ) )
  {
    On0Status = SetNewState ( Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device01ID ) )
  {
    On1Status = SetNewState ( Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device03ID ) )
  {
    On3Status = SetNewState ( Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device02ID ) )
  {
    On2Status = SetNewState ( Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device11ID ) )
  {
    SetValue ( Analog1Value , Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device12ID ) )
  {
    SetValue ( Analog2Value , Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device13ID ) )
  {
    SetValue ( Analog3Value , Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device14ID ) )
  {
    SetValue ( Analog4Value , Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device15ID ) )
  {
    SetValue ( Analog5Value , Command ) ;
    return ;
  }   ;
  if ( CompStr ( DeviceID , Device16ID ) )
  {
    SetValue ( Analog6Value , Command ) ;
    return ;
  }   ;
  DataError ( ) ;
}  


void SerialPool ( void )
{
  UCHAR Ch ;
   
  if ( UART1DataPresent ( ) )
  {
    Ch = UART1GetData ( ) ;
    if ( Ch == 0x0D )
    {
      ExecuteSerialCommand ( ) ;
      CommandIndex = 0 ;
    }  
    else
    {
      if ( CommandIndex < 32 )
      {
        CommandBuffer [ CommandIndex ] = Ch ;
        CommandBuffer [ CommandIndex + 1 ] = 0 ;
        CommandIndex ++ ;
      }   ;
    }   ;
  }   ;
}  


void Device01On ( void )
{
   
  UART1SendConstString ( Device01ID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( MyDeviceID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( ChOnCommand ) ;
  UART1Send ( 0x0D ) ;
}  


void Device01Off ( void )
{
   
  UART1SendConstString ( Device01ID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( MyDeviceID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( ChOffCommand ) ;
  UART1Send ( 0x0D ) ;
}  


void Device02On ( void )
{
   
  UART1SendConstString ( Device02ID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( MyDeviceID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( ChOnCommand ) ;
  UART1Send ( 0x0D ) ;
}  


void Device02Off ( void )
{
   
  UART1SendConstString ( Device02ID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( MyDeviceID ) ;
  UART1Send ( ':' ) ;
  UART1SendConstString ( ChOffCommand ) ;
  UART1Send ( 0x0D ) ;
}  


static void InitData ( UCHAR * OutData ,
                       UCHAR * InData )
{
  UCHAR Ch ;
   
  for ( ; ; )
  {
    Ch = * InData ++ ;
    * OutData ++ = Ch ;
    if ( ! Ch )
    return ;
  }   ;
}  


void InitDataService ( void )
{
   
  InitData ( Analog1Value , ( UCHAR * ) "??,?" ) ;
  InitData ( Analog2Value , ( UCHAR * ) "??,?" ) ;
  InitData ( Analog3Value , ( UCHAR * ) "??,?" ) ;
  InitData ( Analog4Value , ( UCHAR * ) "??,?" ) ;
  InitData ( Analog5Value , ( UCHAR * ) "??,?" ) ;
  InitData ( Analog6Value , ( UCHAR * ) "??,?" ) ;
  On0Status = 0 ;
  On1Status = 0 ;
  On2Status = 0 ;
  On3Status = 0 ;
  CommandIndex = 0 ;
}  

