#line 1 "frameutil.c"
























 

#line 1 "frameutil.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "frameutil.h"
#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "frameutil.h"
#line 1 "ipservice.h"
























 





#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 28 "frameutil.c"
#line 29 "frameutil.c"

USHORT AutoIdentyficationCounter ;

static USHORT CalculateDataChecksum ( ULONG  StartCheckSum ,
                                      void * StartBuffer ,
                                      USHORT BufferSize )
{
  ULONG Sum ;
  USHORT * Buffer ;
   
  Sum = StartCheckSum ;
  Buffer = ( USHORT * ) StartBuffer ;
  while ( BufferSize > 1 )
  {
    Sum += * Buffer ++ ;
    BufferSize -= 2 ;
  }   ;
  if ( BufferSize )
    Sum += * ( UCHAR * ) Buffer ;
  while ( Sum >> 16 )
    Sum = ( Sum & 0xFFFF ) + ( Sum >> 16 ) ;
  return ( ( USHORT ) ( ~ Sum ) ) ;
}  


static USHORT CalculateChecksumWithPseudoHeader ( ULONG  PseudoHeaderCheckSum ,
                                                  void * StartBuffer ,
                                                  USHORT BufferSize )
{
  ULONG Sum ;
  USHORT * Buffer ;
   
  Sum = PseudoHeaderCheckSum ;
  Buffer = ( USHORT * ) StartBuffer ;
  while ( BufferSize > 1 )
  {
    Sum += SwapBytes ( * Buffer ++ ) ;
    BufferSize -= 2 ;
  }   ;
  if ( BufferSize )
  {
      Sum += ( * ( UCHAR * ) Buffer ) << 8 ;
  }   ;
  while ( Sum >> 16 )
    Sum = ( Sum & 0xFFFF ) + ( Sum >> 16 ) ;
  return ( ( USHORT ) ( ~ Sum ) ) ;
}  


static ULONG CalcPseudoHeaderCheckSum ( ULONG  SourceIPAddress ,
                                        ULONG  DestinationIPAddress ,
                                        USHORT Protocol ,
                                        USHORT BufferSize )
{
  ULONG CheckSum ;
   
  CheckSum = ( SourceIPAddress >> 16 ) + ( SourceIPAddress & 0xFFFF ) ;
  CheckSum += ( DestinationIPAddress >> 16 ) + ( DestinationIPAddress & 0xFFFF ) ;
  CheckSum += ( ULONG ) Protocol + ( ULONG ) BufferSize ;
  return ( CheckSum ) ;
}  


USHORT CalculateChecksum ( void * StartBuffer ,
                           USHORT BufferSize )
{
   
  return ( CalculateDataChecksum ( 0 , StartBuffer , BufferSize ) ) ;
}  


USHORT CalculateUDPChecksum ( ULONG  SourceIPAddress ,
                              ULONG  DestinationIPAddress ,
                              void * StartBuffer ,
                              USHORT BufferSize )
{
   
  return ( CalculateChecksumWithPseudoHeader ( CalcPseudoHeaderCheckSum ( SourceIPAddress ,
                                                                          DestinationIPAddress ,
                                                                          17 , BufferSize ) ,
                                               StartBuffer , BufferSize ) ) ;
}  


USHORT CalculateTCPChecksum ( ULONG  SourceIPAddress ,
                              ULONG  DestinationIPAddress ,
                              void * StartBuffer ,
                              USHORT BufferSize )
{
   
  return ( CalculateChecksumWithPseudoHeader ( CalcPseudoHeaderCheckSum ( SourceIPAddress ,
                                                                          DestinationIPAddress ,
                                                                          6 , BufferSize ) ,
                                               StartBuffer , BufferSize ) ) ;
}  


void GetByteArrayField ( void *         DestinationAddress ,
                         PtrOSFrameRecT Frame ,
                         USHORT         FieldOffset ,
                         USHORT         FieldSize )
{
  ULONG Loop ;
  UCHAR * SourceData ;
  UCHAR * DestinationData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  DestinationData = ( UCHAR * ) DestinationAddress ;
  for ( Loop = 0 ; Loop < FieldSize ; Loop ++ )
    * DestinationData ++ = * SourceData ++ ;
}  


UCHAR GetUCHARField ( PtrOSFrameRecT Frame ,
                      USHORT         FieldOffset )
{
   
  return ( Frame -> Data [ FieldOffset ] ) ;
}  


USHORT GetUSHORTSwapField ( PtrOSFrameRecT Frame ,
                            USHORT         FieldOffset )
{
  UCHAR Ch1 ;
  UCHAR Ch2 ;
  UCHAR * SourceData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  Ch1 = * SourceData ++ ;
  Ch2 = * SourceData ++ ;
  return ( Ch1 << 8 ) | Ch2 ;
}  


ULONG GetULONGSwapField ( PtrOSFrameRecT Frame ,
                          USHORT         FieldOffset )
{
  UCHAR Ch1 ;
  UCHAR Ch2 ;
  UCHAR Ch3 ;
  UCHAR Ch4 ;
  UCHAR * SourceData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  Ch1 = * SourceData ++ ;
  Ch2 = * SourceData ++ ;
  Ch3 = * SourceData ++ ;
  Ch4 = * SourceData ++ ;
  return ( Ch1 << 24 ) | ( Ch2 << 16 ) | ( Ch3 << 8 ) | Ch4 ;
}  


void AddByteArrayField ( PtrOSFrameRecT Frame ,
                         void *         SourceAddress ,
                         USHORT         FieldSize )
{
  ULONG Loop ;
  UCHAR * SourceData ;
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + Frame -> Length ;
  Frame -> Length += FieldSize ;
  SourceData = ( UCHAR * ) SourceAddress ;
  for ( Loop = 0 ; Loop < FieldSize ; Loop ++ )
    * DestinationData ++ = * SourceData ++ ;
}  


void AddDuplByteField ( PtrOSFrameRecT Frame ,
                        UCHAR          Data ,
                        USHORT         FieldSize )
{
  ULONG Loop ;
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + Frame -> Length ;
  Frame -> Length += FieldSize ;
  for ( Loop = 0 ; Loop < FieldSize ; Loop ++ )
    * DestinationData ++ = Data ;
}  


void AddByteField ( PtrOSFrameRecT Frame ,
                    UCHAR          Data )
{
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + Frame -> Length ;
  Frame -> Length ++ ;
  * DestinationData = Data ;
}  


void AddUSHORTSwapField ( PtrOSFrameRecT Frame ,
                          USHORT         Value )
{
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + Frame -> Length ;
  Frame -> Length += 2 ;
  * DestinationData ++ = ( UCHAR ) ( ( Value >> 8 ) & 0xFF ) ;
  * DestinationData = ( UCHAR ) ( Value & 0xFF ) ;
}  


void AddULONGSwapField ( PtrOSFrameRecT Frame ,
                         ULONG          Value )
{
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + Frame -> Length ;
  Frame -> Length += 4 ;
  * DestinationData ++ = ( UCHAR ) ( ( Value >> 24 ) & 0xFF ) ;
  * DestinationData ++ = ( UCHAR ) ( ( Value >> 16 ) & 0xFF ) ;
  * DestinationData ++ = ( UCHAR ) ( ( Value >> 8 ) & 0xFF ) ;
  * DestinationData = ( UCHAR ) ( Value & 0xFF ) ;
}  


void PutByteArrayField ( PtrOSFrameRecT Frame ,
                         USHORT         FieldOffset ,
                         void *         SourceAddress ,
                         USHORT         FieldSize )
{
  ULONG Loop ;
  UCHAR * SourceData ;
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  SourceData = ( UCHAR * ) SourceAddress ;
  for ( Loop = 0 ; Loop < FieldSize ; Loop ++ )
    * DestinationData ++ = * SourceData ++ ;
}  


void PutUSHORTSwapField ( PtrOSFrameRecT Frame ,
                          USHORT         FieldOffset ,
                          USHORT         Value )
{
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  * DestinationData ++ = ( UCHAR ) ( ( Value >> 8 ) & 0xFF ) ;
  * DestinationData = ( UCHAR ) ( Value & 0xFF ) ;
}  


void PutUSHORTNoSwapField ( PtrOSFrameRecT Frame ,
                            USHORT         FieldOffset ,
                            USHORT         Value )
{
  UCHAR * DestinationData ;
   
  DestinationData = ( UCHAR * ) Frame -> Data + FieldOffset ;
  * DestinationData ++ = ( UCHAR ) ( Value & 0xFF ) ;
  * DestinationData = ( UCHAR ) ( ( Value >> 8 ) & 0xFF ) ;
}  


void StartEthFrame ( PtrOSFrameRecT Frame ,
                     UCHAR *        DestMACAddress ,
                     UCHAR *        SrcMACAddress ,
                     USHORT         LenghtOrType )
{
  ULONG Loop ;
   
  Frame -> Length = 0 ;
  Frame -> Index = 0 ;
  if ( DestMACAddress )
    AddByteArrayField ( Frame , DestMACAddress , 6 ) ;
  else
  {
    for ( Loop = 0 ; Loop < 6 ; Loop ++ )
      AddByteField ( Frame , 0x00 ) ;
  }   ;
  AddByteArrayField ( Frame , SrcMACAddress , 6 ) ;
  AddUSHORTSwapField ( Frame , LenghtOrType ) ;
}  


void CreateIPHeader ( PtrOSFrameRecT Frame ,
                      UCHAR          Protocol ,
                      ULONG          SrcIPAddress ,
                      ULONG          DstIPAddress )
{
   
  AddByteField ( Frame , 0x45 ) ;
  AddByteField ( Frame , 0 ) ;
  AddUSHORTSwapField ( Frame , 0 ) ;         
  AddUSHORTSwapField ( Frame , AutoIdentyficationCounter ++ ) ;
  AddUSHORTSwapField ( Frame , 0 ) ;         
  AddByteField ( Frame , 64 ) ;
  AddByteField ( Frame , Protocol ) ;
  AddUSHORTSwapField ( Frame , 0 ) ;         
  AddULONGSwapField ( Frame , SrcIPAddress ) ;
  AddULONGSwapField ( Frame , DstIPAddress ) ;
}  


void SkipByteArrayField ( PtrOSFrameRecT Frame ,
                          USHORT         FieldSize )
{
   
  Frame -> Index += FieldSize ;
}  


void ReadByteArrayField ( void *         DestinationAddress ,
                          PtrOSFrameRecT Frame ,
                          USHORT         FieldSize )
{
  ULONG Loop ;
  UCHAR * SourceData ;
  UCHAR * DestinationData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + Frame -> Index ;
  Frame -> Index += FieldSize ;
  DestinationData = ( UCHAR * ) DestinationAddress ;
  for ( Loop = 0 ; Loop < FieldSize ; Loop ++ )
    * DestinationData ++ = * SourceData ++ ;
}  


UCHAR ReadUCHARField ( PtrOSFrameRecT Frame )
{
  UCHAR Ch ;
   
  Ch = Frame -> Data [ Frame -> Index ] ;
  Frame -> Index ++ ;
  return ( Ch ) ;
}  


USHORT ReadUSHORTSwapField ( PtrOSFrameRecT Frame )
{
  UCHAR Ch1 ;
  UCHAR Ch2 ;
  UCHAR * SourceData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + Frame -> Index ;
  Frame -> Index += 2 ;
  Ch1 = * SourceData ++ ;
  Ch2 = * SourceData ++ ;
  return ( Ch1 << 8 ) | Ch2 ;
}  


ULONG ReadULONGSwapField ( PtrOSFrameRecT Frame )
{
  UCHAR Ch1 ;
  UCHAR Ch2 ;
  UCHAR Ch3 ;
  UCHAR Ch4 ;
  UCHAR * SourceData ;
   
  SourceData = ( UCHAR * ) Frame -> Data + Frame -> Index ;
  Frame -> Index += 4 ;
  Ch1 = * SourceData ++ ;
  Ch2 = * SourceData ++ ;
  Ch3 = * SourceData ++ ;
  Ch4 = * SourceData ++ ;
  return ( Ch1 << 24 ) | ( Ch2 << 16 ) | ( Ch3 << 8 ) | Ch4 ;
}  


void GetEthHeader ( EtherPackedHeaderRecT * EtherHeader ,
                    PtrOSFrameRecT          Frame )
{
   
  GetByteArrayField ( EtherHeader -> DestinMACAddress , Frame , 0 ,
                      6 ) ;
  GetByteArrayField ( EtherHeader -> SourceMACAddress , Frame , 0 + 6 ,
                      6 ) ;
  EtherHeader -> LengthOrType = GetUSHORTSwapField ( Frame , 0 + 6 + 6 ) ;
}  


void GetIPHeader ( IPHeaderRecT * IPHeader ,
                   PtrOSFrameRecT Frame )
{
  UCHAR Temp ;
   
  Temp = ReadUCHARField ( Frame ) ;
  IPHeader -> Vers = ( Temp >> 4 ) & 0x0F ;
  IPHeader -> HLen = Temp & 0x0F ;
  IPHeader -> ServiceType = ReadUCHARField ( Frame ) ;
  IPHeader -> TotalLength = ReadUSHORTSwapField ( Frame ) ;
  IPHeader -> Identification = ReadUSHORTSwapField ( Frame ) ;
  IPHeader -> FragmentOffs = ReadUSHORTSwapField ( Frame ) ;
  IPHeader -> Flags = ( UCHAR ) ( ( IPHeader -> FragmentOffs >> 12 ) & 0x0F ) ;
  IPHeader -> FragmentOffs &= 0x0FFF ;
  IPHeader -> TTL = ReadUCHARField ( Frame ) ;
  IPHeader -> Protocol = ReadUCHARField ( Frame ) ;
  IPHeader -> HeaderChecksum = ReadUSHORTSwapField ( Frame ) ;
  IPHeader -> SourceIPAddress = ReadULONGSwapField ( Frame ) ;
  IPHeader -> DestinationIPAddress = ReadULONGSwapField ( Frame ) ;
}  


void SetIPHeaderOrgin ( PtrOSFrameRecT Frame )
{
   
  Frame -> Index = 14 ;
}  


USHORT SwapBytes ( USHORT Data )
{
   
  return ( Data >> 8 ) | ( Data << 8 ) ;
}  

