#line 1 "icmpservice.c"
























 


#line 1 "icmpservice.h"
























 





#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 32 "icmpservice.h"
#line 1 "ipservice.h"
























 





#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 33 "icmpservice.h"

extern void ProcessICMPPacked ( PtrIPLayerInstanceRecT   ,
                                IPHeaderRecT *           ,
                                PtrOSFrameRecT           ) ;

extern void SetICMPEchoService ( IPLayerInstanceRecT *      ,
                                 ProcessProtPServiceProcT   ) ;

extern void SendPingTo ( IPLayerInstanceRecT *   ,
                         ULONG                   ,
                   const UCHAR *                 ) ;

#line 29 "icmpservice.c"
#line 30 "icmpservice.c"
#line 31 "icmpservice.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 32 "icmpservice.c"
























 

static void SendICMPEcho ( PtrIPLayerInstanceRecT IPLayerInstance ,
                           IPHeaderRecT *         IPHeader ,
                           PtrOSFrameRecT         Frame )
{
  EMACInstanceRecT * InterfInstance ;
  EtherPackedHeaderRecT EtherHeader ;
  PtrOSFrameRecT OutFrame ;
  USHORT ICMPDataSize ;
  USHORT CheckSum ;
   
  if ( IPHeader -> TotalLength > 60 )
  {
    ICMPDataSize = 60 - 20 - 4 ;
  }  
  else
  {
    if ( IPHeader -> TotalLength > ( 20 + 4 ) )
      ICMPDataSize = IPHeader -> TotalLength - 20 - 4 ;
    else
      return ;
  }   ;
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( OutFrame )
  {

    GetEthHeader ( & EtherHeader , Frame ) ;
    StartEthFrame ( OutFrame , EtherHeader . SourceMACAddress ,
                    InterfInstance -> InterfaceMACAddress , 0x0800 ) ;
    CreateIPHeader ( OutFrame , 1 , IPLayerInstance -> MyLocalIPAddress ,
                     IPHeader -> SourceIPAddress ) ;
    PutUSHORTSwapField ( OutFrame , 14 + 2 , ICMPDataSize + 20 + 4 ) ;
    CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 0 ] , 20 ) ;
    PutUSHORTNoSwapField ( OutFrame , 14 + 10 , CheckSum ) ;
    AddUSHORTSwapField ( OutFrame , 0x0000 ) ;
    AddUSHORTSwapField ( OutFrame , 0 ) ;    
    AddByteArrayField ( OutFrame , & Frame -> Data [ 14 + 20 + 4 ] , ICMPDataSize ) ;
    CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 20 ] , ICMPDataSize + 4 ) ;
    PutUSHORTNoSwapField ( OutFrame , 14 + 20 + 2 , CheckSum ) ;
    InterfInstance -> InterfaceSendFrame ( OutFrame ) ;

    InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  }   ;
}  


void ProcessICMPPacked ( PtrIPLayerInstanceRecT IPLayerInstance ,
                         IPHeaderRecT *         IPHeader ,
                         PtrOSFrameRecT         Frame )
{
  USHORT TypeAndCode ;
   
  TypeAndCode = GetUSHORTSwapField ( Frame , 14 + 20 ) ;
  switch ( TypeAndCode )
  {
    case 0x0800      :
      SendICMPEcho ( IPLayerInstance , IPHeader , Frame ) ;
      break ;
    case 0x0000    :
      if ( IPLayerInstance -> ICMPEchoProcessService )
        IPLayerInstance -> ICMPEchoProcessService ( IPLayerInstance , IPHeader , Frame ) ;
      break ;
    default :
      ;
  }   ;
}  


static USHORT StrLen ( const UCHAR * Str )
{
  const UCHAR * SaveStr = Str ;
   
  while ( * SaveStr ++ )
    ;
  return ( SaveStr - Str - 1 ) ;
}  


void SetICMPEchoService ( IPLayerInstanceRecT *    IPLayerInstance ,
                          ProcessProtPServiceProcT EchoService )
{
   
  IPLayerInstance -> ICMPEchoProcessService = EchoService ;
}  


void SendPingTo ( IPLayerInstanceRecT * IPLayerInstance ,
                  ULONG                 IPAddress ,
            const UCHAR *               Data )
{
  EMACInstanceRecT * InterfInstance ;
  PtrOSFrameRecT OutFrame ;
  ULONG TargetAddress ;
  USHORT ICMPDataSize ;
  USHORT CheckSum ;
   
  if ( ( IPAddress & IPLayerInstance -> MyLocalNetMask ) ==
       ( IPLayerInstance -> MyLocalIPAddress & IPLayerInstance -> MyLocalNetMask ) )
  {
    TargetAddress = IPAddress ;
  }  
  else
  {
    TargetAddress = IPLayerInstance-> MyDefaultGWIPAddress ;
    if ( ! TargetAddress )
    {
      return ;
    }   ;
  }   ;
  ICMPDataSize = StrLen ( Data ) + 4 ;
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;

  StartEthFrame ( OutFrame , ( void * ) 0 , InterfInstance -> InterfaceMACAddress , 0x0800 ) ;
  CreateIPHeader ( OutFrame , 1 , IPLayerInstance -> MyLocalIPAddress , IPAddress ) ;
  PutUSHORTSwapField ( OutFrame , 14 + 2 , ICMPDataSize + 20 + 4 ) ;
  CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 0 ] , 20 ) ;
  PutUSHORTNoSwapField ( OutFrame , 14 + 10 , CheckSum ) ;
  AddUSHORTSwapField ( OutFrame , 0x0800 ) ;
  AddUSHORTSwapField ( OutFrame , 0 ) ;     
  AddUSHORTSwapField ( OutFrame , 12 ) ;    
  AddUSHORTSwapField ( OutFrame , 34 ) ;    
  AddByteArrayField ( OutFrame , ( void * ) Data , ICMPDataSize - 4 ) ;
  CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 20 ] , ICMPDataSize + 4 ) ;
  PutUSHORTNoSwapField ( OutFrame , 14 + 20 + 2 , CheckSum ) ;
  IPLayerInstance -> SendIPPackedService ( IPLayerInstance , OutFrame , TargetAddress ) ;
  InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
}  



