#line 1 "ipmemservice.c"
























 

#line 1 "ipmemservice.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "ipmemservice.h"
#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "ipmemservice.h"


extern PtrOSFrameRecT FrameMemoryAllocate ( ULONG   ) ;

extern void FrameMemoryDeallocate ( PtrOSFrameRecT   ) ;

extern void InitIPLayerMemoryService ( void ) ;

#line 28 "ipmemservice.c"
#line 29 "ipmemservice.c"
#line 30 "ipmemservice.c"





typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;
                 UCHAR         Data [ 1536 ] ;
               } MemFrameRecT ;
typedef struct {
                 UCHAR                   BusyFlag [ 8 ] ;
                 PtrOSFrameRecT          FrameBuffer [ 8 ] ;
                 MemFrameRecT            BufferBody [ 8 ] ;
               } FramePoolRecT ;


static FramePoolRecT FramePool ;


PtrOSFrameRecT FrameMemoryAllocate ( ULONG Size )
{
  ULONG Loop ;
  PtrOSFrameRecT Frame ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( ! FramePool . BusyFlag [ Loop ] )
    {
      FramePool . BusyFlag [ Loop ] = 1 ;
      Frame =  FramePool . FrameBuffer [ Loop ] ;
      Frame -> Length = 0 ;
      Frame -> Index = 0 ;
      return ( Frame ) ;
    }   ;
  }   ;
  return ( void * ) 0 ;
}  


void FrameMemoryDeallocate ( PtrOSFrameRecT Frame )
{
  ULONG Loop ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( FramePool . FrameBuffer [ Loop ] == Frame )
    {
      FramePool . BusyFlag [ Loop ] = 0 ;
      return ;
    }   ;
  }   ;
}  


void InitIPLayerMemoryService ( void )
{
  ULONG Loop ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    FramePool . BusyFlag [ Loop ] = 0 ;
    FramePool . FrameBuffer [ Loop ] = ( PtrOSFrameRecT ) & ( FramePool . BufferBody [ Loop ] ) ;
  }   ;
}  

