#line 1 "strings.c"
























 

#line 1 "strings.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "strings.h"


extern void memclear ( void *   ,
                       USHORT   ) ;

extern void memcopy ( void *   ,
                      void *   ,
                      USHORT   ) ;

extern UCHAR Cap ( UCHAR   ) ;

extern void StrCpy ( UCHAR *   ,
               const UCHAR *   ) ;

extern USHORT StrLen ( UCHAR *   ) ;

extern void StrDelete ( UCHAR *   ,
                        USHORT    ,
                        USHORT    ) ;

extern void StrNorm ( UCHAR *   ) ;

extern void StrExp ( USHORT    ,
                     UCHAR *   ) ;

extern void AppendCh ( UCHAR *   ,
                       UCHAR     ) ;

extern void AppendStr ( UCHAR *   ,
                  const UCHAR *   ) ;

extern void Append ( USHORT    ,
                     UCHAR *   ,
               const UCHAR *   ) ;

extern UCHAR * BegOfString ( UCHAR *   ) ;

extern void WordToHexStr ( UCHAR *   ,
                           USHORT    ,
                           UCHAR     ,
                           USHORT    ) ;

extern void WordToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        USHORT    ) ;

extern void LongToStr ( UCHAR *   ,
                        USHORT    ,
                        UCHAR     ,
                        ULONG     ) ;

extern void IPToString ( UCHAR *   ,
                         ULONG     ) ;

extern UCHAR Digit ( UCHAR   ) ;

extern UCHAR StrToCard ( UCHAR *    ,
                         USHORT *   ) ;

extern UCHAR StrToLCard ( UCHAR *   ,
                          ULONG *   ) ;

extern UCHAR CompareString ( UCHAR *   ,
                             UCHAR *   ,
                             USHORT    ) ;

extern UCHAR StrToIP ( UCHAR *   ,
                       ULONG *   ) ;

#line 28 "strings.c"


static const UCHAR CnvTable [ 16 ] = { '0','1','2','3','4','5','6','7',
                                       '8','9','A','B','C','D','E','F'} ;


void memclear ( void * Buff ,
                USHORT Size )
{
  UCHAR * Byte = ( UCHAR * ) Buff ;
   
  while ( Size )
  {
    * Byte ++ = 0 ;
    Size -- ;
  }   ;
}  


void memcopy ( void * DestAdr ,
               void * SourAdr ,
               USHORT Size )
{
  UCHAR * IByte = ( UCHAR * ) SourAdr ;
  UCHAR * OByte = ( UCHAR * ) DestAdr ;
   
  while ( Size )
  {
    * OByte ++ = * IByte ++ ;
    Size -- ;
  }   ;
}  


UCHAR Cap ( UCHAR Ch )
{
   
  if ( ( Ch >= 'a' ) && ( Ch <= 'z' ) )
    return ( Ch - 32 ) ;
  else
    return ( Ch ) ;
}  


void StrCpy ( UCHAR * DestStr ,
        const UCHAR * SourStr )
{
   
  while ( * DestStr ++ = * SourStr ++ )
    ;
}  


USHORT StrLen ( UCHAR * Str )
{
  UCHAR * SaveStr = Str ;
   
  while ( * SaveStr ++ )
    ;
  return ( SaveStr - Str - 1 ) ;
}  


void StrDelete ( UCHAR * String ,
                 USHORT  ChPos ,
                 USHORT  Lgt )
{
  UCHAR * InStr = String + ChPos + Lgt ;
  UCHAR * OutStr = String + ChPos ;
   
  while ( * OutStr ++ = * InStr ++ )
    ;
}  


void StrNorm ( UCHAR * String )
{
  USHORT SpaceCt = 0 ;
  UCHAR * Ch = String ;
   
  while ( * Ch ++ == ' ' )
    SpaceCt ++ ;
  if ( SpaceCt )
    StrDelete ( String , 0 , SpaceCt ) ;
  if ( * String )
  {
    while ( * String ++ )
      ;
    String -- ;
    String -- ;
    while ( * String == ' ' )
    {
      * String -- = '\0' ;
    }   ;
  }   ;
}  


void StrExp ( USHORT  MaxSize ,
              UCHAR * String  )
{
  UCHAR * Str = String ;
   
  while ( * Str )
  {
    if ( ! MaxSize -- )
      return ;
    Str ++ ;
  }   ;
  if ( MaxSize == 1 )
  {
    * Str = '\0' ;
  }  
  else
  {
    MaxSize -- ;
    while ( MaxSize )
    {
      * Str ++ = ' ' ;
      MaxSize -- ;
    }   ;
    * Str = '\0' ;
  }   ;
}  


void AppendCh ( UCHAR * String ,
                UCHAR   AppCh )
{
   
  while ( * String )
  {
    String ++ ;
  }   ;
  * String ++ = AppCh ;
  * String = ( UCHAR ) 0 ;
}  


void AppendStr ( UCHAR * Str ,
           const UCHAR * AppStr )
{
  UCHAR Ch ;
   
  while ( * Str )
  {
    Str ++ ;
  }   ;
  for ( ; ; )
  {
    Ch = * ( AppStr ++ ) ;
    * ( Str ++ ) = Ch ;
    if ( ! Ch )
      return ;
  }   ;
}  


void Append ( USHORT  MaxSize ,
              UCHAR * String ,
        const UCHAR * SubStr )
{
   
  while ( * String )
  {
    if ( ! MaxSize -- )
      return ;
    String ++ ;
  }   ;
  if ( MaxSize )
  {
    for ( ; ; )
    {
      if ( MaxSize -- == 1 )
      {
        * String = '\0' ;
        return ;
      }   ;
      if ( ! ( * String ++ = * SubStr ++ ) )
        return ;
    }   ;
  }   ;
}  


UCHAR * BegOfString ( UCHAR * String )
{
   
  while ( ( * String ) == ' ' )
    String ++ ;
  return ( String ) ;
}  


void WordToHexStr ( UCHAR * Number ,
                    USHORT  ConvWidth ,
                    UCHAR   EmptyCh ,
                    USHORT  CardV )
{
  USHORT Loop ;
  UCHAR LocalBuffer [ 12 ] ;
   
  if ( ConvWidth > 7 )
  {
    * Number ++ = '!' ;
    * Number = ( UCHAR ) 0 ;
    return ;
  }   ;
  for ( Loop = 0 ; Loop < ConvWidth ; Loop ++ )
    LocalBuffer [ Loop ] = EmptyCh ;
  LocalBuffer [ ConvWidth ] = ( UCHAR ) 0 ;
  Loop = ConvWidth - 1 ;
  for ( ; ; )
  {
    LocalBuffer [ Loop ] = CnvTable [ CardV & 0x0F ] ;
    CardV = CardV >> 4 ;
    if ( ( ! Loop ) || ( ! CardV ) )
      break ;
    Loop -- ;
  }   ;
  for ( Loop = 0 ; Loop <= ConvWidth ; Loop ++ )
    * Number ++ = LocalBuffer [ Loop ] ;
}  


void WordToStr ( UCHAR * Number ,
                 USHORT  ConvWidth ,
                 UCHAR   EmptyCh ,
                 USHORT  Value )
{
  USHORT Loop ;
  UCHAR LocalBuffer [ 12 ] ;
  UCHAR LastDigit ;
   
  if ( ConvWidth > 7 )
  {
    * Number ++ = '!' ;
    * Number = ( UCHAR ) 0 ;
    return ;
  }   ;
  for ( Loop = 0 ; Loop < ConvWidth ; Loop ++ )
    LocalBuffer [ Loop ] = EmptyCh ;
  LocalBuffer [ ConvWidth ] = ( UCHAR ) 0 ;
  Loop = ConvWidth - 1 ;
  for ( ; ; )
  {
    LastDigit = ( UCHAR ) ( Value % 10 ) ;
    LocalBuffer [ Loop ] = LastDigit + ( UCHAR ) 0x30 ;
    Value = Value / 10 ;
    if ( ( ! Loop ) || ( ! Value ) )
      break ;
    Loop -- ;
  }   ;
  for ( Loop = 0 ; Loop <= ConvWidth ; Loop ++ )
    * Number ++ = LocalBuffer [ Loop ] ;
}  


void LongToStr ( UCHAR * Number ,
                 USHORT  ConvWidth ,
                 UCHAR   EmptyCh ,
                 ULONG   Value )
{
  USHORT Loop ;
  UCHAR LocalBuffer [ 20 ] ;
  UCHAR LastDigit ;
   
  if ( ConvWidth > 16 )
  {
    * Number ++ = ( UCHAR ) '!' ;
    * Number = ( UCHAR ) 0 ;
    return ;
  }   ;
  for ( Loop = 0 ; Loop < ConvWidth ; Loop ++ )
    LocalBuffer [ Loop ] = EmptyCh ;
  LocalBuffer [ ConvWidth ] = ( UCHAR ) 0 ;
  Loop = ConvWidth - 1 ;
  for ( ; ; )
  {
    LastDigit = ( UCHAR ) ( Value % ( ULONG ) 10 ) ;
    LocalBuffer [ Loop ] = LastDigit + ( UCHAR ) 0x30 ;
    Value = Value / ( ULONG ) 10 ;
    if ( ( ! Loop ) || ( ! Value ) )
      break ;
    Loop -- ;
  }   ;
  for ( Loop = 0 ; Loop <= ConvWidth ; Loop ++ )
    * Number ++ = LocalBuffer [ Loop ] ;
}  


void IPToString ( UCHAR * ConvBuff ,
                  ULONG   IPAddress )
{
  UCHAR CnvPart [ 6 ] ;
  UCHAR B0 ;
  UCHAR B1 ;
  UCHAR B2 ;
  UCHAR B3 ;
   
  * ConvBuff = 0 ;
  B0 = ( UCHAR ) ( ( IPAddress >> 24 ) & 0xFF ) ;
  B1 = ( UCHAR ) ( ( IPAddress >> 16 ) & 0xFF ) ;
  B2 = ( UCHAR ) ( ( IPAddress >> 8 ) & 0xFF ) ;
  B3 = ( UCHAR ) ( IPAddress & 0xFF ) ;
  WordToStr ( CnvPart , 3 , ( UCHAR ) ' ' , ( USHORT ) B0 ) ;
  AppendStr ( ConvBuff , BegOfString ( CnvPart ) ) ;
  AppendCh ( ConvBuff , '.' ) ;
  WordToStr ( CnvPart , 3 , ( UCHAR ) ' ' , ( USHORT ) B1 ) ;
  AppendStr ( ConvBuff , BegOfString ( CnvPart ) ) ;
  AppendCh ( ConvBuff , '.' ) ;
  WordToStr ( CnvPart , 3 , ( UCHAR ) ' ' , ( USHORT ) B2 ) ;
  AppendStr ( ConvBuff , BegOfString ( CnvPart ) ) ;
  AppendCh ( ConvBuff , '.' ) ;
  WordToStr ( CnvPart , 3 , ( UCHAR ) ' ' , ( USHORT ) B3 ) ;
  AppendStr ( ConvBuff , BegOfString ( CnvPart ) ) ;
}  


UCHAR Digit ( UCHAR Character )
{
   
  return ( ( Character >= '0' ) && ( Character <= '9' ) ) ;
}  


UCHAR StrToCard ( UCHAR *  String ,
                  USHORT * Result )
{
  USHORT WorkResult ;
  UCHAR Ch ;
   
  * Result = 0 ;
  WorkResult = 0 ;
  Ch = * ( String ++ ) ;
  while ( Ch )
  {
    if ( Digit ( Ch ) )
      WorkResult = WorkResult * 10 + ( USHORT ) ( Ch - '0' ) ;
    else
      return ( ( 0 ) ) ;
    Ch = * ( String ++ ) ;
  }   ;
  * Result = WorkResult ;
  return ( ( 1 ) ) ;
}  


UCHAR StrToLCard ( UCHAR * String ,
                   ULONG * Result )
{
  ULONG WorkResult ;
  UCHAR Ch ;
   
  * Result = 0 ;
  WorkResult = 0 ;
  Ch = * ( String ++ ) ;
  while ( Ch )
  {
    if ( Digit ( Ch ) )
      WorkResult = WorkResult * 10 + ( ULONG ) ( Ch - '0' ) ;
    else
      return ( ( 0 ) ) ;
    Ch = * ( String ++ ) ;
  }   ;
  * Result = WorkResult ;
  return ( ( 1 ) ) ;
}  


UCHAR CompareString ( UCHAR * String1 ,
                      UCHAR * String2 ,
                      USHORT  Size )
{
  UCHAR Loop ;
   
  for ( Loop = 0 ; Loop < Size ; Loop ++ )
  {
    if ( ( * String1 ) != ( * String2 ) )
      return ( ( 0 ) ) ;
    String1 ++ ;
    String2 ++ ;
  }   ;
  return ( ( 1 ) ) ;
}  


UCHAR StrToIP ( UCHAR * IPString ,
                ULONG * IPBinary )
{
  UCHAR WorkNum [ 8 ] ;
  ULONG IPAdr ;
  USHORT AdrPart ;
  UCHAR Loop ;
  UCHAR Cycle ;
  UCHAR Done ;
  UCHAR TermCh ;
  UCHAR Ch = 0 ;
   
  IPAdr = 0 ;
  for ( Cycle = 0 ; Cycle < 4 ; Cycle ++ )
  {
    for ( Loop = 0 ; Loop < 8 ; Loop ++ )
      WorkNum [ Loop ] = 0 ;
    for ( Loop = 0 ; Loop < 7 ; Loop ++ )
    {
      Ch = * ( IPString ++ ) ;
      if ( Digit ( Ch ) )
        WorkNum [ Loop ] = Ch ;
      else
        break ;
    }   ;
    if ( Cycle == 3 )
      TermCh = 0 ;
    else
      TermCh = '.' ;
    if ( Ch != TermCh )
      return ( ( 0 ) ) ;
    Done = StrToCard ( WorkNum , & AdrPart ) ;
    if ( ! Done )
      return ( ( 0 ) ) ;
    if ( AdrPart >= 256 )
      return ( ( 0 ) ) ;
    IPAdr = ( IPAdr << 8 ) + ( ULONG ) AdrPart ;
  }   ;
  * IPBinary = IPAdr ;
  return ( ( 1 ) ) ;
}  


