#line 1 "systime.c"
























 
#line 1 "systime.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "systime.h"

typedef void ( * TimeServiceProcT ) ( void *   ) ;

typedef struct {
                 ULONG             BellTime ;
                 void *            CallParam ;
                 TimeServiceProcT  CallService ;
               } TimeQueueRecT ;
typedef TimeQueueRecT * PtrTimeQueueRecT ;


extern void SysTimeEnevtService ( void ) ;

extern PtrTimeQueueRecT AttachTimer ( ULONG               ,
                                      TimeServiceProcT    ,
                                      void *              ) ;

extern void DetachTimer ( PtrTimeQueueRecT   ) ;

void SysTimerPool ( void ) ;

void InitSysTime ( void ) ;

#line 27 "systime.c"
#line 28 "systime.c"



typedef struct {
                  volatile ULONG    GeneralTimerConter ;
                  TimeQueueRecT     TimeQueue [ 16 ] ;
                  UCHAR             TimeQueueStatus [ 16 ] ;
               } SysTimeInstanceRecType ;

static SysTimeInstanceRecType SysTimeInstance ;
               

void SysTimeEnevtService ( void )
{
   
  SysTimeInstance . GeneralTimerConter ++ ;
}  


PtrTimeQueueRecT AttachTimer ( ULONG             RelativeAlarmTime ,
                               TimeServiceProcT  CallService ,
                               void *            CallParam )
{
  USHORT Loop ;
  ULONG AlarmTime ;
  PtrTimeQueueRecT QueueElementPtr ;
   
  QueueElementPtr = ( void * ) 0 ;
  AlarmTime = SysTimeInstance . GeneralTimerConter + RelativeAlarmTime ;
  if ( ! AlarmTime )
    AlarmTime ++ ;
  for ( Loop = 0 ; Loop < 16 ; Loop ++ )
  {
    if ( ! SysTimeInstance . TimeQueueStatus [ Loop ] )
    {
      SysTimeInstance . TimeQueueStatus [ Loop ] = 1 ;
      QueueElementPtr = & SysTimeInstance . TimeQueue [ Loop ] ;
      QueueElementPtr -> BellTime = AlarmTime ;
      QueueElementPtr -> CallParam = CallParam ;
      QueueElementPtr -> CallService = CallService ;
      return ( QueueElementPtr ) ;
    }   ;
  }   ;
  return ( ( void * ) 0 ) ;
}  


void DetachTimer ( PtrTimeQueueRecT TimeQueueElement )
{
  USHORT Loop ;
  PtrTimeQueueRecT QueueElementPtr ;
   
  for ( Loop = 0 ; Loop < 16 ; Loop ++ )
  {
    QueueElementPtr = & SysTimeInstance . TimeQueue [ Loop ] ;
    if ( TimeQueueElement == QueueElementPtr )
    {
      SysTimeInstance . TimeQueueStatus [ Loop ] = 0 ;
      break ;
    }   ;
  }   ;
}  


void SysTimerPool ( void )
{
  USHORT Loop ;
  PtrTimeQueueRecT QueueElementPtr ;
  ULONG TimeDif ;
   
  for ( Loop = 0 ; Loop < 16 ; Loop ++ )
  {
    if ( SysTimeInstance . TimeQueueStatus [ Loop ] )
    {
      QueueElementPtr = & SysTimeInstance . TimeQueue [ Loop ] ;
      if ( QueueElementPtr -> BellTime )
      {
        TimeDif = QueueElementPtr -> BellTime - SysTimeInstance . GeneralTimerConter ;
        if ( ( TimeDif == 0 ) || ( TimeDif & 0x80000000 ) )
        {
          SysTimeInstance . TimeQueueStatus [ Loop ] = 0 ;
          QueueElementPtr -> BellTime = 0 ;
          QueueElementPtr -> CallService ( QueueElementPtr -> CallParam ) ;
        }   ;
      }   ;
    }   ;
  }   ;
}  


void InitSysTime ( void )
{
  USHORT Loop ;
   
  SysTimeInstance . GeneralTimerConter = 0 ;
  for ( Loop = 0 ; Loop < 16 ; Loop ++ )
  {
    SysTimeInstance . TimeQueueStatus [ Loop ] = 0 ;
  }   ;
}  

