#line 1 "tcpservice.c"
























 


#line 1 "tcpservice.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "tcpservice.h"
#line 1 "ipservice.h"
























 





#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 32 "tcpservice.h"




struct _TCPLayerInstanceRec ;

typedef struct _TCPLayerInstanceRec * PtrTCPLayerInstanceRecT ;

typedef enum { CLOSED        ,
               LISTENING     ,
               SYN_SENT      ,
               SYN_RECEIVED  ,
               ESTABLISHED   ,
               FIN_WAIT_1    ,
               FIN_WAIT_2    ,
               CLOSE_WAIT    ,
               CLOSING       ,
               LAST_ACK      ,
               TIME_WAIT     } TCPStateMachineType ;

struct _TCPSocketDescriptionRec ;

typedef struct _TCPSocketDescriptionRec * PtrTCPSocketDescriptionRecT ;

typedef USHORT ( * TCPConnetOperationProcT ) ( PtrTCPSocketDescriptionRecT   ,
                                               ULONG                         ,
                                               USHORT                        ) ;

typedef void ( * TCPEstablishOperationProcT ) ( PtrTCPSocketDescriptionRecT   ) ;

typedef void ( * TCPCloseOperationProcT ) ( PtrTCPSocketDescriptionRecT   ) ;

typedef void ( * TCPRecvOperationProcT ) ( PtrTCPSocketDescriptionRecT   ,
                                           ULONG                         ,
                                           USHORT                        ,
                                           ULONG                         ,
                                           USHORT                        ,
                                           void *                        ,
                                           USHORT                        ) ;




struct _TCPWindowDescr ;

typedef struct _TCPWindowDescr * PtrTCPWindowDescrRecT ;

typedef struct _TCPWindowDescr {
                 USHORT                      WritePtr ;
                 USHORT                      ReadPtr ;
                 USHORT                      DataLength ;
                 UCHAR                       DataBuffer [ 1024 ] ;
                 PtrTCPWindowDescrRecT       FwdLink ;
               } TCPWindowDescrRecT ;

typedef enum { None            ,
               LastSend_FIN    ,
               LastSend_SYN    ,
               LastSend_SYNACC ,
               LastSend_PSH    ,
               LastSend_RST    } TCPLastSendType ;

typedef struct {
                 TCPLastSendType             TCPLastSend ;
                 USHORT                      DelayTime ;
                 USHORT                      Counter ;
               } RetransmRecT ;
typedef RetransmRecT * PtrRetransmRecT ;

typedef struct _TCPSocketDescriptionRec {
                 PtrTCPSocketDescriptionRecT NextSocketLink ;
                 PtrTCPLayerInstanceRecT     TCPLayerInstanceLink ;
                 PtrTCPWindowDescrRecT       WindowLink ;
                 RetransmRecT                RetransmData ;
                 TCPStateMachineType         TCPStateMachine ;               
                 ULONG                       RemoteAddr ;                    
                 ULONG                       LocalAddress ;                  
                 USHORT                      RemotePort ;                    
                 USHORT                      LocalPort ;                     
                 ULONG                       SND_UNA ;                       
                 ULONG                       SND_NXT ;                       
                 USHORT                      SND_WND ;                       
                 USHORT                      SND_UP ;                        
                 ULONG                       SND_WL1 ;                       
                 ULONG                       SND_WL2 ;                       
                 ULONG                       ISS ;                           
                 ULONG                       RCV_NXT ;                       
                 USHORT                      RCV_WND ;                       
                 USHORT                      RCV_UP ;                        
                 ULONG                       IRS ;                           
                 TCPConnetOperationProcT     ConnectNotify ;
                 TCPEstablishOperationProcT  EstablishNotify ;
                 TCPRecvOperationProcT       ReceiveNotify ;
                 TCPCloseOperationProcT      CloseNotify ;
               } TCPSocketDescriptionRecT ;


typedef struct _TCPLayerInstanceRec
               { PtrIPLayerInstanceRecT       IPLayerInstance ;
                 PtrTCPSocketDescriptionRecT  ListenSocketTopEntry ;
                 PtrTCPSocketDescriptionRecT  TransmSocketTopEntry ;
                 USHORT                       LastLocalPort ;
                 ULONG                        InitSequenceNumber ;
               } TCPLayerInstanceRecT ;




extern USHORT TCPOpen ( PtrTCPSocketDescriptionRecT    ,
                        ULONG                          ,
                        USHORT                         ,
                        TCPEstablishOperationProcT     ,
                        TCPRecvOperationProcT          ,
                        TCPCloseOperationProcT         ) ;




extern USHORT TCPClose ( PtrTCPSocketDescriptionRecT   ) ;





extern USHORT TCPSendData ( PtrTCPSocketDescriptionRecT   ,
                            void *                        ,
                            USHORT                        ) ;

extern void DeallocateSocket ( PtrTCPSocketDescriptionRecT   ) ;

extern PtrTCPSocketDescriptionRecT CreateTCPSocket ( PtrTCPLayerInstanceRecT   ) ;





extern USHORT TCPListen ( PtrTCPSocketDescriptionRecT    ,
                          TCPConnetOperationProcT        ,
                          TCPEstablishOperationProcT     ,
                          TCPRecvOperationProcT          ,
                          TCPCloseOperationProcT         ) ;

extern PtrTCPLayerInstanceRecT GetTCPInstance ( PtrTCPSocketDescriptionRecT   ) ;





extern USHORT BindTCPSocket ( PtrTCPSocketDescriptionRecT   ,
                              USHORT                        ) ;

extern void TCPInitInstance ( PtrTCPLayerInstanceRecT   ,
                              PtrIPLayerInstanceRecT    ) ;

extern PtrIPLayerInstanceRecT GetIPInstanceTCP ( PtrTCPLayerInstanceRecT   ) ;

extern PtrTCPLayerInstanceRecT StandardAddTCPInstance ( PtrIPLayerInstanceRecT   ) ;

#line 29 "tcpservice.c"
#line 30 "tcpservice.c"
#line 31 "tcpservice.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 32 "tcpservice.c"
#line 1 "systime.h"
























 




#line 31 "systime.h"

typedef void ( * TimeServiceProcT ) ( void *   ) ;

typedef struct {
                 ULONG             BellTime ;
                 void *            CallParam ;
                 TimeServiceProcT  CallService ;
               } TimeQueueRecT ;
typedef TimeQueueRecT * PtrTimeQueueRecT ;


extern void SysTimeEnevtService ( void ) ;

extern PtrTimeQueueRecT AttachTimer ( ULONG               ,
                                      TimeServiceProcT    ,
                                      void *              ) ;

extern void DetachTimer ( PtrTimeQueueRecT   ) ;

void SysTimerPool ( void ) ;

void InitSysTime ( void ) ;

#line 33 "tcpservice.c"
#line 1 "xramservice.h"























 
 



#line 30 "xramservice.h"

extern PtrTCPWindowDescrRecT AllocateWindowXRAM ( void ) ;

extern void DeallocateWindowXRAM ( PtrTCPWindowDescrRecT   ) ;

extern void InitXRAM ( void ) ;

#line 34 "tcpservice.c"
































































 





#line 110 "tcpservice.c"







#line 125 "tcpservice.c"




typedef struct { USHORT                 SourcePortNo ;
                 USHORT                 DestinationPortNo ;
                 ULONG                  SeqenceNumber ;
                 ULONG                  AcknowledgementNumber ;
                 USHORT                 HeaderLength ;
                 USHORT                 CodeBits ;
                 USHORT                 Window ;
                 USHORT                 TCPCheckSum ;
                 USHORT                 UrgentPointer ;
                 USHORT                 TCPDataSize ;
               } TCPHeaderRecT ;


static TCPSocketDescriptionRecT SocketArray [ 8 ] ;
static UCHAR SocketStatus [ 8 ] ;


static volatile UCHAR WindowTableStatus [ 6 ] ;
static TCPWindowDescrRecT WindowTable [ 6 ] ;

static PtrTCPWindowDescrRecT AllocateWindow ( void )
{
  USHORT Loop ;
   
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
  {
    if ( ! WindowTableStatus [ Loop ] )
    {
      WindowTableStatus [ Loop ] = 1 ;
      return ( & WindowTable [ Loop ] ) ;
    }   ;
  }   ;
  return ( AllocateWindowXRAM ( ) ) ;
}  


static void DeallocateWindow ( PtrTCPWindowDescrRecT Window )
{
  USHORT Loop ;
   
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
  {
    if ( & WindowTable [ Loop ] == Window )
    {
      WindowTableStatus [ Loop ] = 0 ;
      return ;
    }   ;
  }   ;
  DeallocateWindowXRAM ( Window ) ;
}  


static USHORT CheckUniqueSocketNo ( PtrTCPLayerInstanceRecT TCPLayerInstance ,
                                    USHORT                  PortNo )
{
  PtrTCPSocketDescriptionRecT TempSocket ;
   
  TempSocket = TCPLayerInstance -> ListenSocketTopEntry ;
  while ( TempSocket )
  {
    if ( TempSocket -> LocalPort == PortNo )
    {
      return ( ( 0 ) ) ;
    }  
    else
    {
      TempSocket = TempSocket -> NextSocketLink ;
    }   ;
  }   ;
  TempSocket = TCPLayerInstance -> TransmSocketTopEntry ;
  while ( TempSocket )
  {
    if ( TempSocket -> LocalPort == PortNo )
    {
      return ( ( 0 ) ) ;
    }  
    else
    {
      TempSocket = TempSocket -> NextSocketLink ;
    }   ;
  }   ;
  return ( ( 1 ) ) ;
}  


static USHORT AllocTCPPortN ( PtrTCPLayerInstanceRecT TCPLayerInstance )
{
  USHORT PortNo ;
  USHORT Unique ;
   
  for ( ; ; )
  {
    PortNo = TCPLayerInstance -> LastLocalPort ++ ;
    if ( TCPLayerInstance -> LastLocalPort > 4095 )
      TCPLayerInstance -> LastLocalPort = 2048 ;
    Unique = CheckUniqueSocketNo ( TCPLayerInstance , PortNo ) ;
    if ( Unique )
      return ( PortNo ) ;
  }   ;
}  
   

static ULONG GetStartSeqNumber ( PtrTCPLayerInstanceRecT TCPLayerInstance )
{
   
  return ( TCPLayerInstance -> InitSequenceNumber + ( TCPLayerInstance -> InitSequenceNumber << 8 ) ) ;
}  


static void StopTimer ( PtrTCPSocketDescriptionRecT Socket )
{
   
  Socket -> RetransmData . Counter = 0 ;
  Socket -> RetransmData . DelayTime = 0 ;
}  


static void StartTimer ( PtrTCPSocketDescriptionRecT Socket ,
                         TCPLastSendType             LastSendOptionType ,
                         USHORT                      Time )
{
   
  Socket -> RetransmData . Counter = 0 ;
  Socket -> RetransmData . DelayTime = Time ;
  Socket -> RetransmData . TCPLastSend = LastSendOptionType ;
}  


static PtrTCPSocketDescriptionRecT AllocateSocket ( PtrTCPLayerInstanceRecT TCPLayerInstance )
{
  USHORT Loop ;
  PtrTCPSocketDescriptionRecT NewSocket ;
   
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( ! SocketStatus [ Loop ] )
    {
      SocketStatus [ Loop ] = 1 ;
      NewSocket = & SocketArray [ Loop ] ;
      NewSocket -> NextSocketLink = ( void * ) 0 ;
      NewSocket -> WindowLink = ( void * ) 0 ;
      NewSocket -> TCPLayerInstanceLink = TCPLayerInstance ;
      NewSocket -> TCPStateMachine = CLOSED ;
      NewSocket -> RetransmData . Counter = 0 ;
      NewSocket -> RetransmData . TCPLastSend = None ;
      NewSocket -> RetransmData . DelayTime = 0 ;
      NewSocket -> RemoteAddr = 0 ;
      NewSocket -> RemotePort = 0 ;
      NewSocket -> LocalAddress = 0 ;
      NewSocket -> LocalPort = AllocTCPPortN ( TCPLayerInstance ) ;
      NewSocket -> SND_UNA = 0 ;
      NewSocket -> SND_NXT = 0 ;
      NewSocket -> SND_WND = 1024  ;
      NewSocket -> SND_UP = 0 ;
      NewSocket -> SND_WL1 = 0 ;
      NewSocket -> SND_WL2 = 0 ;
      NewSocket -> ISS = 0 ;
      NewSocket -> RCV_NXT = 0 ;
      NewSocket -> RCV_WND = 1024  ;
      NewSocket -> RCV_UP = 0 ;
      NewSocket -> IRS = 0 ;
      NewSocket -> ConnectNotify = ( void * ) 0 ;
      NewSocket -> EstablishNotify = ( void * ) 0 ;
      NewSocket -> ReceiveNotify = ( void * ) 0 ;
      NewSocket -> CloseNotify = ( void * ) 0 ;
      return ( NewSocket ) ;
    }   ;
  }   ;
  return ( ( void * ) 0 ) ;
}  


void DeallocateSocket ( PtrTCPSocketDescriptionRecT TCPSocket )
{
  USHORT Loop ;
  PtrTCPWindowDescrRecT TopWindow ;
  PtrTCPWindowDescrRecT DelWindow ;
   
  TopWindow = TCPSocket -> WindowLink ;
  TCPSocket -> WindowLink = ( void * ) 0 ;
  while ( TopWindow )
  {
    DelWindow = TopWindow ;
    TopWindow = TopWindow -> FwdLink ;
    DeallocateWindow ( DelWindow ) ;
  }   ;
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
  {
    if ( TCPSocket == ( & SocketArray [ Loop ] ) )
    {
      SocketStatus [ Loop ] = 0 ;
      return ;
    }   ;
  }   ;
}  


void FreeTCBSocket ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrTCPSocketDescriptionRecT TmpSocket ;
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
   
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  if ( TCPLayerInstance -> TransmSocketTopEntry == Socket )
  {
    TCPLayerInstance -> TransmSocketTopEntry = Socket -> NextSocketLink ;
    Socket -> NextSocketLink = ( void * ) 0 ;
  }  
  else
  {
    TmpSocket = TCPLayerInstance -> TransmSocketTopEntry ;
    while ( TmpSocket )
    {
      if ( TmpSocket -> NextSocketLink == Socket )
      {
        TmpSocket -> NextSocketLink = Socket -> NextSocketLink ;
        Socket -> NextSocketLink = ( void * ) 0 ;
        break ;
      }  
      else
        TmpSocket = TmpSocket -> NextSocketLink ;
    }   ;
  }   ;
  DeallocateSocket ( Socket ) ;
}  


static void RealDelayedFreeTCBSocket ( void * CallParam )
{
  PtrTCPSocketDescriptionRecT Socket ;
   
  Socket = ( PtrTCPSocketDescriptionRecT ) CallParam ;
  FreeTCBSocket ( Socket ) ;
}  


static void DelayedFreeTCBSocket ( PtrTCPSocketDescriptionRecT Socket )
{
   
  AttachTimer ( 100 , RealDelayedFreeTCBSocket , ( void * ) Socket ) ;
}  


static void AddSocketToListenListe ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
   
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  Socket -> NextSocketLink = TCPLayerInstance -> ListenSocketTopEntry ;
  TCPLayerInstance -> ListenSocketTopEntry = Socket ;
}  


static void AddSocketToTCBListe ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
   
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  Socket -> NextSocketLink = TCPLayerInstance -> TransmSocketTopEntry ;
  TCPLayerInstance -> TransmSocketTopEntry = Socket ;
}  


static ULONG MagicCalculation ( ULONG SeqenceNumber )
{
   
  return ( ( ~ SeqenceNumber ) & 0xFFFFF ) ;
}  


static void SendTCPFrame ( PtrTCPSocketDescriptionRecT Socket ,
                           USHORT                      TCPCodeBits )
{
  PtrIPLayerInstanceRecT IPLayerInstance ;
  EMACInstanceRecT * InterfInstance ;
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  ULONG TargetAddress ;
  PtrOSFrameRecT OutFrame ;
  USHORT CheckSum ;
  void * AllTCPDataBuffer ;
   
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  IPLayerInstance = GetIPInstanceTCP ( TCPLayerInstance ) ;
  InterfInstance = GetEMACInstance ( IPLayerInstance ) ;
  if ( ( Socket -> RemoteAddr & IPLayerInstance -> MyLocalNetMask ) == ( IPLayerInstance -> MyLocalIPAddress & IPLayerInstance -> MyLocalNetMask ) )
  {
    TargetAddress = Socket -> RemoteAddr ;
  }  
  else
  {
    TargetAddress = IPLayerInstance -> MyDefaultGWIPAddress ;
    if ( ! TargetAddress )
    {
      return ;
    }   ;
  }   ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( OutFrame )
  {
    StartEthFrame ( OutFrame , ( void * ) 0 , InterfInstance -> InterfaceMACAddress , 0x0800 ) ;
    CreateIPHeader ( OutFrame , 6 , IPLayerInstance -> MyLocalIPAddress , Socket -> RemoteAddr ) ;
    if ( TCPCodeBits & 0x02 )
      PutUSHORTSwapField ( OutFrame , 14 + 2 , 20 + 20 + 4 ) ;
    else
      PutUSHORTSwapField ( OutFrame , 14 + 2 , 20 + 20 ) ;
    CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 0 ] , 20 ) ;
    PutUSHORTNoSwapField ( OutFrame , 14 + 10 , CheckSum ) ;
    AllTCPDataBuffer = ( void * ) ( OutFrame -> Data + OutFrame -> Length ) ;
    AddUSHORTSwapField ( OutFrame , Socket -> LocalPort ) ;
    AddUSHORTSwapField ( OutFrame , Socket -> RemotePort ) ;
    AddULONGSwapField ( OutFrame , Socket -> SND_NXT ) ;
    AddULONGSwapField ( OutFrame , Socket -> RCV_NXT ) ;
    AddUSHORTSwapField ( OutFrame , 0 ) ;   
    AddUSHORTSwapField ( OutFrame , Socket -> SND_WND ) ;
    AddUSHORTSwapField ( OutFrame , 0 ) ;   
    AddUSHORTSwapField ( OutFrame , Socket -> SND_UP ) ;
    if ( TCPCodeBits & 0x02 )
    {
      PutUSHORTSwapField ( OutFrame , 14 + 20 + 12 , 0x6000 | TCPCodeBits ) ;
      AddUSHORTSwapField ( OutFrame , 0x0204 ) ;
      AddUSHORTSwapField ( OutFrame , 1460 ) ;
    }  
    else
    {
      PutUSHORTSwapField ( OutFrame , 14 + 20 + 12 , 0x5000 | TCPCodeBits ) ;
    }   ;
    CheckSum = CalculateTCPChecksum ( IPLayerInstance -> MyLocalIPAddress , Socket -> RemoteAddr ,
                                      AllTCPDataBuffer , 
                                      OutFrame -> Length - 14 - 20 ) ;
    PutUSHORTSwapField ( OutFrame , 14 + 20 + 16 , CheckSum ) ;
    IPLayerInstance -> SendIPPackedService ( IPLayerInstance , OutFrame , TargetAddress ) ;
    InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  }   ;
}  


static void SendTCPFrameWithData ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrIPLayerInstanceRecT IPLayerInstance ;
  EMACInstanceRecT * InterfInstance ;
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  PtrTCPWindowDescrRecT CurrWindow ;
  ULONG TargetAddress ;
  PtrOSFrameRecT OutFrame ;
  USHORT CheckSum ;
  USHORT RdPointer ;
  USHORT Loop ;
  void * AllTCPDataBuffer ;
   
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  IPLayerInstance = GetIPInstanceTCP ( TCPLayerInstance ) ;
  InterfInstance = GetEMACInstance ( IPLayerInstance ) ;
  if ( ( Socket -> RemoteAddr & IPLayerInstance -> MyLocalNetMask ) == ( IPLayerInstance -> MyLocalIPAddress & IPLayerInstance -> MyLocalNetMask ) )
  {
    TargetAddress = Socket -> RemoteAddr ;
  }  
  else
  {
    TargetAddress = IPLayerInstance-> MyDefaultGWIPAddress ;
    if ( ! TargetAddress )
    {
      return ;
    }   ;
  }   ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( OutFrame )
  {
    CurrWindow  = Socket -> WindowLink ;
    StartEthFrame ( OutFrame , ( void * ) 0 , InterfInstance -> InterfaceMACAddress , 0x0800 ) ;
    CreateIPHeader ( OutFrame , 6 , IPLayerInstance -> MyLocalIPAddress , Socket -> RemoteAddr ) ;
    PutUSHORTSwapField ( OutFrame , 14 + 2 , 20 + 20 + CurrWindow -> DataLength ) ;
    CheckSum = CalculateChecksum ( & OutFrame -> Data [ 14 + 0 ] , 20 ) ;
    PutUSHORTNoSwapField ( OutFrame , 14 + 10 , CheckSum ) ;
    AllTCPDataBuffer = ( void * ) ( OutFrame -> Data + OutFrame -> Length ) ;
    AddUSHORTSwapField ( OutFrame , Socket -> LocalPort ) ;
    AddUSHORTSwapField ( OutFrame , Socket -> RemotePort ) ;
    AddULONGSwapField ( OutFrame , Socket -> SND_NXT ) ;
    AddULONGSwapField ( OutFrame , Socket -> RCV_NXT ) ;
    AddUSHORTSwapField ( OutFrame , 0x5000 | 0x08 | 0x10 ) ;
    AddUSHORTSwapField ( OutFrame , Socket -> SND_WND ) ;
    AddUSHORTSwapField ( OutFrame , 0 ) ;   
    AddUSHORTSwapField ( OutFrame , Socket -> SND_UP ) ;
    RdPointer = CurrWindow -> ReadPtr ;
    for ( Loop = 0 ; Loop < CurrWindow -> DataLength ; Loop ++ )
    {
      AddByteField ( OutFrame , CurrWindow -> DataBuffer [ RdPointer ++ ] ) ;
      if ( RdPointer >= 1024 )
        RdPointer = 0 ;
    }   ;
    CheckSum = CalculateTCPChecksum ( IPLayerInstance -> MyLocalIPAddress , Socket -> RemoteAddr ,
                                      AllTCPDataBuffer , 
                                      OutFrame -> Length - 14 - 20 ) ;
    PutUSHORTSwapField ( OutFrame , 14 + 20 + 16 , CheckSum ) ;
    IPLayerInstance -> SendIPPackedService ( IPLayerInstance , OutFrame , TargetAddress ) ;
    InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  }   ;
}  


static void RetransmitTCPWindow ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrTCPWindowDescrRecT CurrWindow ;
   
  CurrWindow  = Socket -> WindowLink ;
  Socket -> SND_NXT = Socket -> SND_UNA ;
  SendTCPFrameWithData ( Socket ) ;
  StartTimer ( Socket , LastSend_PSH , 0x60 ) ;
  Socket -> SND_NXT += ( ULONG ) CurrWindow -> DataLength ;
}  


USHORT TCPOpen ( PtrTCPSocketDescriptionRecT  Socket ,
                 ULONG                        RemoteIP ,
                 USHORT                       RemotePort ,
                 TCPEstablishOperationProcT   EstablishCallBackService ,
                 TCPRecvOperationProcT        RecvCallBackService ,
                 TCPCloseOperationProcT       CloseCallBackService )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
   
  if ( Socket -> TCPStateMachine != CLOSED )
    return ( 1 ) ;
  TCPLayerInstance = GetTCPInstance ( Socket ) ;
  IPLayerInstance = GetIPInstanceTCP ( TCPLayerInstance ) ;
  AddSocketToTCBListe ( Socket ) ;
  Socket -> RemoteAddr = RemoteIP ;
  Socket -> RemotePort = RemotePort ;
  Socket -> LocalAddress = IPLayerInstance -> MyLocalIPAddress ;
  Socket -> EstablishNotify = EstablishCallBackService ;
  Socket -> ReceiveNotify = RecvCallBackService ;
  Socket -> CloseNotify = CloseCallBackService ;
  Socket -> ISS = GetStartSeqNumber ( TCPLayerInstance ) ;
  Socket -> SND_UNA = Socket -> ISS ;
  Socket -> SND_NXT = Socket -> ISS ;
  Socket -> SND_UP = 0 ;
  Socket -> SND_WL1 = 0 ;
  Socket -> SND_WL2 = 0 ;
  Socket -> RCV_NXT = 0 ;
  Socket -> RCV_UP = 0 ;
  Socket -> IRS = 0 ;
  SendTCPFrame ( Socket , 0x02 ) ;
  StartTimer ( Socket , LastSend_SYN , 0x20 ) ;
  Socket -> TCPStateMachine = SYN_SENT ;
  return ( 0 ) ;
}  


USHORT TCPClose ( PtrTCPSocketDescriptionRecT Socket )
{
   
  if ( Socket -> TCPStateMachine != ESTABLISHED )
    return ( 1 ) ;
  SendTCPFrame ( Socket , 0x01 | 0x10 ) ;
  Socket -> SND_NXT ++ ;
  StartTimer ( Socket , LastSend_FIN , 0x20 ) ;
  Socket -> TCPStateMachine = FIN_WAIT_1 ;
  return ( 0 ) ;
}  


static void SendCurrentSegment ( PtrTCPSocketDescriptionRecT Socket )
{
  PtrTCPWindowDescrRecT CurrWindow ;
   
  CurrWindow  = Socket -> WindowLink ;
  SendTCPFrameWithData ( Socket ) ;
  StartTimer ( Socket , LastSend_PSH , 0x20 ) ;
  Socket -> SND_NXT += ( ULONG ) CurrWindow -> DataLength ;
}  


USHORT TCPSendData ( PtrTCPSocketDescriptionRecT Socket ,
                     void *                      DataBufferPtr ,
                     USHORT                      DataSize )
{
  PtrTCPWindowDescrRecT NewWindow ;
  PtrTCPWindowDescrRecT CurrWindow ;
  USHORT Loop ;
  UCHAR * InputBuffer ;
   
  if ( Socket -> TCPStateMachine != ESTABLISHED )
  {
    return ( 1 ) ;
  }   ;
  if ( DataSize > 1024 )
  {
    return ( 2 ) ;
  }   ;
  InputBuffer = ( UCHAR * ) DataBufferPtr ;
  if ( ! Socket -> WindowLink )
  {
    NewWindow  = AllocateWindow ( ) ;
    if ( ! NewWindow )
    {
      return ( 2 ) ;
    }   ;
    NewWindow -> WritePtr = 0 ;
    NewWindow -> ReadPtr = 0 ;
    NewWindow -> DataLength = 0 ;
    NewWindow -> FwdLink = ( void * ) 0 ;
    Socket -> WindowLink = NewWindow ;
    for ( Loop = 0 ; Loop < DataSize ; Loop ++ )
    {
      NewWindow -> DataBuffer [ NewWindow -> WritePtr ++ ] = * InputBuffer ++ ;
      NewWindow -> DataLength ++ ;
    }   ;
    SendCurrentSegment ( Socket ) ;
    return ( 0 ) ;
  }  
  else
  {
    CurrWindow = Socket -> WindowLink ;
    NewWindow = CurrWindow -> FwdLink ;
    if ( ! NewWindow )
    {
      NewWindow  = AllocateWindow ( ) ;
      if ( ! NewWindow )
      {
        return ( 2 ) ;
      }   ;
      NewWindow -> WritePtr = 0 ;
      NewWindow -> ReadPtr = 0 ;
      NewWindow -> DataLength = 0 ;
      NewWindow -> FwdLink = ( void * ) 0 ;
      CurrWindow -> FwdLink = NewWindow ;
    }   ;
    if ( ( NewWindow -> DataLength + DataSize ) > 1024 )
    {
      return ( 2 ) ;
    }   ;
    for ( Loop = 0 ; Loop < DataSize ; Loop ++ )
    {
      NewWindow -> DataBuffer [ NewWindow -> WritePtr ++ ] = * InputBuffer ++ ;
      NewWindow -> DataLength ++ ;
    }   ;
    return ( 0 ) ;
  }   ;
}  


static void EndOfConn ( PtrTCPSocketDescriptionRecT Socket )
{
   
  if ( Socket -> CloseNotify )
    Socket -> CloseNotify ( Socket ) ;
  DelayedFreeTCBSocket ( Socket ) ;

}  


static void KillSocket ( PtrTCPSocketDescriptionRecT Socket )
{
   
  SendTCPFrame ( Socket , 0x04 ) ;
  EndOfConn ( Socket ) ;
}  


static void SetStartSocketInfo ( PtrTCPSocketDescriptionRecT TCBSocket ,
                                 IPHeaderRecT *              IPHeader ,
                                 TCPHeaderRecT *             TCPHeader )
{
   
  TCBSocket -> RemoteAddr = IPHeader -> SourceIPAddress ;
  TCBSocket -> LocalAddress = IPHeader -> DestinationIPAddress ;
  TCBSocket -> RemotePort = TCPHeader -> SourcePortNo ;
  TCBSocket -> LocalPort = TCPHeader -> DestinationPortNo ;
  TCBSocket -> ISS = MagicCalculation ( TCPHeader -> SeqenceNumber ) ;
  TCBSocket -> SND_UNA = TCBSocket -> ISS ;
  TCBSocket -> SND_NXT = TCBSocket -> ISS ;
  TCBSocket -> SND_WND = 1024 ;
  TCBSocket -> SND_UP = 0 ;     
  TCBSocket -> SND_WL1 = 0 ;    
  TCBSocket -> SND_WL2 = 0 ;    
  TCBSocket -> IRS = TCPHeader -> SeqenceNumber ;
  TCBSocket -> RCV_NXT = TCBSocket -> IRS + 1 ;
  TCBSocket -> RCV_WND = TCPHeader -> Window ;
  TCBSocket -> RCV_UP = TCPHeader -> UrgentPointer ;
}  


static void ReceiveData ( PtrIPLayerInstanceRecT      IPLayerInstance ,
                          PtrTCPSocketDescriptionRecT Socket ,
                          TCPHeaderRecT *             TCPHeader ,
                          PtrOSFrameRecT              Frame )
{
  ULONG Dif ;
  USHORT UserDataSize ;
  UCHAR * TCPBuffer ;
   
  TCPBuffer = Frame -> Data + Frame -> Index ;
  if ( Socket -> RCV_NXT == TCPHeader -> SeqenceNumber )
  {
    Socket -> RCV_NXT = Socket -> RCV_NXT + TCPHeader -> TCPDataSize ;
    SendTCPFrame ( Socket , 0x10 ) ;
    if ( Socket -> ReceiveNotify )
    {
      Socket -> ReceiveNotify ( Socket , Socket -> RemoteAddr , Socket -> RemotePort ,
                                Socket -> LocalAddress , Socket -> LocalPort ,
                                ( void * ) ( TCPBuffer ) , TCPHeader -> TCPDataSize ) ;
    }   ;
  }  
  else
  {
    Dif = Socket -> RCV_NXT - TCPHeader -> SeqenceNumber ;
    if ( ! ( Dif & 0x80000000 ) )
    {
      if ( ( USHORT ) Dif < TCPHeader -> TCPDataSize )
      {
        UserDataSize = TCPHeader -> TCPDataSize - ( USHORT ) Dif ;
        if ( Socket -> ReceiveNotify )
        {
          Socket -> ReceiveNotify ( Socket , Socket -> RemoteAddr , Socket -> RemotePort ,
                                    Socket -> LocalAddress , Socket -> LocalPort ,
                                    ( void * ) ( TCPBuffer + ( USHORT ) Dif ) , UserDataSize ) ;
        }   ;
        Socket -> RCV_NXT = TCPHeader -> SeqenceNumber + TCPHeader -> TCPDataSize ;
      }   ;
      SendTCPFrame ( Socket , 0x10 ) ;
    }  
    else
    {
      SendTCPFrame ( Socket , 0x10 ) ;
    }   ;
  }   ;
}  


static void AnalyseOptions ( PtrTCPSocketDescriptionRecT Socket ,
                             TCPHeaderRecT *             TCPHeader ,
                             PtrOSFrameRecT              Frame )
{
   
  Socket -> RCV_WND = 1460 ;
}  


static void AcceptLastWindowData ( PtrTCPSocketDescriptionRecT Socket ,
                                   TCPHeaderRecT *             TCPHeader )
{
  PtrTCPWindowDescrRecT CurrWindow ;
   
  CurrWindow  = Socket -> WindowLink ;
  if ( CurrWindow )
  {
    if ( TCPHeader -> AcknowledgementNumber == Socket -> SND_NXT )
    {
      StopTimer ( Socket ) ;
      Socket -> SND_UNA = TCPHeader -> AcknowledgementNumber ;
      if ( CurrWindow -> FwdLink )
      {
        Socket -> WindowLink = CurrWindow -> FwdLink ;
        DeallocateWindow ( CurrWindow ) ;
        SendCurrentSegment ( Socket ) ;
      }  
      else
      {
        DeallocateWindow ( CurrWindow ) ;
        Socket -> WindowLink = ( void * ) 0 ;
      }   ;
    }  
    else
    {
    }   ;
  }   ;
}  


static void TCPReceivedStateMachine ( PtrIPLayerInstanceRecT      IPLayerInstance ,
                                      PtrTCPSocketDescriptionRecT Socket ,
                                      IPHeaderRecT *              IPHeader ,
                                      TCPHeaderRecT *             TCPHeader ,
                                      PtrOSFrameRecT              Frame )
{














































  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  PtrTCPSocketDescriptionRecT TCBSocket ;
  USHORT CallBackResult ;
   
  TCPLayerInstance = ( PtrTCPLayerInstanceRecT ) IPLayerInstance -> TCPInstanceEntry ;
  TCPHeader -> CodeBits &= ~ 0x20 ;
  switch ( Socket -> TCPStateMachine )
  {
    case CLOSED        :
      break ;
    case LISTENING     :













 
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        DelayedFreeTCBSocket ( Socket ) ;

        break ;
      }   ;
      if ( ! ( TCPHeader -> CodeBits & 0x02 ) )
      {
        Socket -> SND_NXT = TCPHeader -> SeqenceNumber ;
        Socket -> RemoteAddr = IPHeader -> SourceIPAddress ;
        Socket -> LocalAddress = IPHeader -> DestinationIPAddress ;
        Socket -> RemotePort = TCPHeader -> SourcePortNo ;
        Socket -> LocalPort = TCPHeader -> DestinationPortNo ;
        SendTCPFrame ( Socket , 0x04 ) ;
        DelayedFreeTCBSocket ( Socket ) ;

        break ;
      }  
      else
      {
        CallBackResult = ( 1 ) ;
        if ( Socket -> ConnectNotify )
        {
          CallBackResult = Socket -> ConnectNotify ( Socket , IPHeader -> SourceIPAddress ,
                                                     TCPHeader -> SourcePortNo ) ;
        }   ;
        if ( CallBackResult )
        {
          TCBSocket = CreateTCPSocket ( TCPLayerInstance ) ;
          * TCBSocket = * Socket ;
          AnalyseOptions ( TCBSocket , TCPHeader , Frame ) ;
          AddSocketToTCBListe ( TCBSocket ) ;
          TCBSocket -> TCPStateMachine = SYN_RECEIVED ;
          SetStartSocketInfo ( TCBSocket , IPHeader , TCPHeader ) ;
          SendTCPFrame ( TCBSocket , 0x02 | 0x10 ) ;
          StartTimer ( TCBSocket , LastSend_SYNACC , 0x20 ) ;
          FreeTCBSocket ( Socket ) ;
        }  
        else
        {
          SetStartSocketInfo ( Socket , IPHeader , TCPHeader ) ;
          SendTCPFrame ( Socket , 0x04 ) ;
          DelayedFreeTCBSocket ( Socket ) ;

        }   ;
      }   ;
      break ;
    case SYN_SENT      :

















 
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        DelayedFreeTCBSocket ( Socket ) ;

        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x02 )
      {
        StopTimer ( Socket ) ;
        Socket -> SND_NXT ++ ;
        Socket -> SND_UNA = Socket -> SND_NXT ;
        Socket -> IRS = TCPHeader -> SeqenceNumber ;
        Socket -> RCV_NXT = Socket -> IRS + 1 ;
        Socket -> RCV_UP = 0 ;
        SendTCPFrame ( Socket , 0x10 ) ;
        if ( TCPHeader -> CodeBits & 0x10 )
        {
          Socket -> TCPStateMachine = ESTABLISHED ;
          if ( Socket -> EstablishNotify )
            Socket -> EstablishNotify ( Socket ) ;
        }  
        else
        {
          Socket -> TCPStateMachine = SYN_RECEIVED ;
        }   ;
      }   ;
      break ;
    case SYN_RECEIVED  :




















 
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        DelayedFreeTCBSocket ( Socket ) ;

        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x02 )
      {                                       
                                              
        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x10 )
      {
        if ( TCPHeader -> AcknowledgementNumber == ( Socket -> SND_NXT + 1 ) )
        {                                       
          StopTimer ( Socket ) ;
          Socket -> SND_NXT ++ ;
          Socket -> SND_UNA = Socket -> SND_NXT ;
          Socket -> TCPStateMachine = ESTABLISHED ;
          if ( Socket -> EstablishNotify )
            Socket -> EstablishNotify ( Socket ) ;
        }  
        else
        {
          KillSocket ( Socket ) ;
        }   ;
      }  
      else
      {
        StopTimer ( Socket ) ;
        Socket -> TCPStateMachine = ESTABLISHED ;
        if ( Socket -> EstablishNotify )
          Socket -> EstablishNotify ( Socket ) ;
        TCPReceivedStateMachine ( IPLayerInstance , Socket , IPHeader , TCPHeader , Frame ) ;
      }   ;
      break ;
    case ESTABLISHED   :










 
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        EndOfConn ( Socket ) ;
        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x10 )
      {
        AcceptLastWindowData ( Socket , TCPHeader ) ;
      }   ;
      if ( TCPHeader -> TCPDataSize )
      {
        ReceiveData ( IPLayerInstance , Socket , TCPHeader , Frame ) ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x01 )
      {
        StopTimer ( Socket ) ;



        Socket -> TCPStateMachine = LAST_ACK ;
        Socket -> RCV_NXT ++ ;
        SendTCPFrame ( Socket , 0x10 | 0x01 ) ;
        StartTimer ( Socket , LastSend_FIN , 0x20 ) ;
      }   ;
      break ;
    case FIN_WAIT_1    :











 
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        EndOfConn ( Socket ) ;
        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x02 )
      {
        KillSocket ( Socket ) ;
        break ;
      }   ;
      StopTimer ( Socket ) ;
      if ( TCPHeader -> CodeBits & 0x10 )
      {
        if ( TCPHeader -> CodeBits & 0x01 )
        {
          Socket -> RCV_NXT ++ ;
          SendTCPFrame ( Socket , 0x10 ) ;
          Socket -> TCPStateMachine = CLOSED ;
          EndOfConn ( Socket ) ;
        }  
        else
        {
          Socket -> TCPStateMachine = FIN_WAIT_2 ;
        }   ;
      }  
      else
      {
        if ( TCPHeader -> CodeBits & 0x01 )
        {
          Socket -> RCV_NXT ++ ;
          SendTCPFrame ( Socket , 0x10 ) ;
          Socket -> TCPStateMachine = CLOSING ;
        }  
        else
        {
        }   ;
      }   ;
      break ;
    case FIN_WAIT_2    :










 
      if ( TCPHeader -> TCPDataSize )
      {
        ReceiveData ( IPLayerInstance , Socket , TCPHeader , Frame ) ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        EndOfConn ( Socket ) ;
        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x01 )
      {
        StopTimer ( Socket ) ;
        Socket -> RCV_NXT ++ ;
        SendTCPFrame ( Socket , 0x10 ) ;
        Socket -> TCPStateMachine = CLOSED ;
        if ( Socket -> CloseNotify )
          Socket -> CloseNotify ( Socket ) ;
        DelayedFreeTCBSocket ( Socket ) ;

      }   ;
      break ;
    case CLOSE_WAIT    :











 
      StopTimer ( Socket ) ;
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        EndOfConn ( Socket ) ;
        break ;
      }   ;
      SendTCPFrame ( Socket , 0x01 ) ;
      StartTimer ( Socket , LastSend_FIN , 0x20 ) ;
      Socket -> TCPStateMachine = LAST_ACK ;
      break ;
    case CLOSING       :










 
      StopTimer ( Socket ) ;
      if ( TCPHeader -> CodeBits & 0x04 )
      {
        EndOfConn ( Socket ) ;
        break ;
      }   ;
      if ( TCPHeader -> CodeBits & 0x10 )
      {
        Socket -> TCPStateMachine = TIME_WAIT ;
      }   ;
      break ;
    case LAST_ACK      :
      Socket -> TCPStateMachine = CLOSED ;
      EndOfConn ( Socket ) ;
      break ;
    case TIME_WAIT     :
      Socket -> TCPStateMachine = CLOSED ;
      EndOfConn ( Socket ) ;
      break ;
  }   ;
}  


static void Reject ( PtrIPLayerInstanceRecT      IPLayerInstance ,
                     PtrTCPSocketDescriptionRecT Socket ,
                     IPHeaderRecT *              IPHeader ,
                     TCPHeaderRecT *             TCPHeader ,
                     PtrOSFrameRecT              Frame )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  PtrTCPSocketDescriptionRecT TCBSocket ;
   
  TCPLayerInstance = ( PtrTCPLayerInstanceRecT ) IPLayerInstance -> TCPInstanceEntry ;
  TCBSocket = CreateTCPSocket ( TCPLayerInstance ) ;
  if ( TCBSocket )
  {
    SetStartSocketInfo ( TCBSocket , IPHeader , TCPHeader ) ;
    TCBSocket -> SND_NXT = TCPHeader -> AcknowledgementNumber ;
    TCBSocket -> RCV_NXT = TCPHeader -> SeqenceNumber ;
    TCBSocket -> ConnectNotify = ( void * ) 0 ;
    TCBSocket -> EstablishNotify = ( void * ) 0 ;
    TCBSocket -> ReceiveNotify = ( void * ) 0 ;
    TCBSocket -> CloseNotify = ( void * ) 0 ;
    SendTCPFrame ( TCBSocket , 0x04 ) ;
    DelayedFreeTCBSocket ( Socket ) ;

  }   ;
}  


static PtrTCPSocketDescriptionRecT LocateSocket_TCB ( PtrTCPLayerInstanceRecT TCPLayerInstance ,
                                                      ULONG                   SourceIPAddress ,
                                                      USHORT                  SourcePortNo ,
                                                      ULONG                   DestinationIPAddress ,
                                                      USHORT                  DestinationPortNo )
{
  PtrTCPSocketDescriptionRecT TempSocket ;
   
  TempSocket = TCPLayerInstance -> TransmSocketTopEntry ;
  while ( TempSocket )
  {
    if ( ( TempSocket -> RemoteAddr == SourceIPAddress ) &&
         ( TempSocket -> RemotePort == SourcePortNo ) &&
         ( TempSocket -> LocalAddress == DestinationIPAddress ) &&
         ( TempSocket -> LocalPort == DestinationPortNo ) )
      break ;
    TempSocket = TempSocket -> NextSocketLink ;
  }   ;
  return ( TempSocket ) ;
}   ;


static PtrTCPSocketDescriptionRecT LocateSocket_Listen ( PtrTCPLayerInstanceRecT TCPLayerInstance ,
                                                         ULONG                   DestinationIPAddress ,
                                                         USHORT                  DestinationPortNo )
{
  PtrTCPSocketDescriptionRecT TempSocket ;
   
  TempSocket = TCPLayerInstance -> ListenSocketTopEntry ;
  while ( TempSocket )
  {
    if ( ( TempSocket -> LocalAddress == DestinationIPAddress ) &&
         ( TempSocket -> LocalPort == DestinationPortNo ) )
      break ;
    TempSocket = TempSocket -> NextSocketLink ;
  }   ;
  return ( TempSocket ) ;
}   ;


static void ProcessTCPPacked ( PtrIPLayerInstanceRecT IPLayerInstance ,
                               IPHeaderRecT *         IPHeader ,
                               PtrOSFrameRecT         Frame )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  TCPHeaderRecT TCPHeader ;
  PtrTCPSocketDescriptionRecT TCBSocket ;
  USHORT Temp ;
  PtrTCPSocketDescriptionRecT Socket ;
   
  TCPLayerInstance = ( PtrTCPLayerInstanceRecT ) IPLayerInstance -> TCPInstanceEntry ;
  TCPHeader . SourcePortNo = ReadUSHORTSwapField ( Frame ) ;
  TCPHeader . DestinationPortNo = ReadUSHORTSwapField ( Frame ) ;
  TCPHeader . SeqenceNumber = ReadULONGSwapField ( Frame ) ;
  TCPHeader . AcknowledgementNumber = ReadULONGSwapField ( Frame ) ;
  Temp = ReadUSHORTSwapField ( Frame ) ;
  TCPHeader . HeaderLength = ( Temp & 0xF000 ) >> 10 ;
  TCPHeader . CodeBits = Temp & 0x3F ;
  TCPHeader . Window = ReadUSHORTSwapField ( Frame ) ;
  TCPHeader . TCPCheckSum = ReadUSHORTSwapField ( Frame ) ;
  TCPHeader . UrgentPointer = ReadUSHORTSwapField ( Frame ) ;
  Temp = 20 + TCPHeader . HeaderLength ;
  if ( IPHeader -> TotalLength >= Temp )
  {
    TCPHeader . TCPDataSize = IPHeader -> TotalLength - Temp ;
    if ( TCPHeader . HeaderLength > 20 )
    {
      SkipByteArrayField ( Frame , TCPHeader . HeaderLength - 20 ) ;
    }   ;
    Socket = LocateSocket_TCB ( TCPLayerInstance , IPHeader -> SourceIPAddress , TCPHeader . SourcePortNo ,
                                IPHeader -> DestinationIPAddress , TCPHeader . DestinationPortNo ) ;
    if ( ! Socket )
    {
      Socket = LocateSocket_Listen ( TCPLayerInstance , IPHeader -> DestinationIPAddress ,
                                     TCPHeader . DestinationPortNo ) ;
      if ( Socket )
      {
        TCBSocket = CreateTCPSocket ( TCPLayerInstance ) ;
        * TCBSocket = * Socket ;
        AddSocketToTCBListe ( TCBSocket ) ;
        Socket = TCBSocket ;
      }   ;
    }   ;
    if ( Socket )
    {
      TCPReceivedStateMachine ( IPLayerInstance , Socket , IPHeader , & TCPHeader , Frame ) ;
    }  
    else
    {
      Reject ( IPLayerInstance , Socket , IPHeader , & TCPHeader , Frame ) ;
    }   ;
  }   ;
}  


PtrTCPSocketDescriptionRecT CreateTCPSocket ( PtrTCPLayerInstanceRecT TCPLayerInstance )

{
  PtrTCPSocketDescriptionRecT NewSocket ;
   
  NewSocket = AllocateSocket ( TCPLayerInstance ) ;
  return ( NewSocket ) ;
}  


USHORT BindTCPSocket ( PtrTCPSocketDescriptionRecT TCPSocket ,
                       USHORT                      TCPPortNo )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  USHORT Unique ;
   
  TCPLayerInstance = GetTCPInstance ( TCPSocket ) ;
  if ( TCPSocket -> TCPStateMachine != CLOSED )
    return ( 2 ) ;
  Unique = CheckUniqueSocketNo ( TCPLayerInstance , TCPPortNo ) ;
  if ( ! Unique )
    return ( 1 ) ;
  TCPSocket -> LocalPort = TCPPortNo ;
  return ( 0 ) ;
}  


USHORT TCPListen ( PtrTCPSocketDescriptionRecT  TCPSocket ,
                   TCPConnetOperationProcT      ConnetCallBackService ,
                   TCPEstablishOperationProcT   EstablishCallBackService ,
                   TCPRecvOperationProcT        RecvCallBackService ,
                   TCPCloseOperationProcT       CloseCallBackService )
{
  PtrIPLayerInstanceRecT IPLayerInstance ;
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
   
  TCPLayerInstance = GetTCPInstance ( TCPSocket ) ;
  if ( TCPSocket -> TCPStateMachine != CLOSED )
    return ( 1 ) ;
  IPLayerInstance = GetIPInstanceTCP ( TCPLayerInstance ) ;
  AddSocketToListenListe ( TCPSocket ) ;
  TCPSocket -> TCPStateMachine = LISTENING ;
  TCPSocket -> LocalAddress = IPLayerInstance -> MyLocalIPAddress ;
  TCPSocket -> ConnectNotify = ConnetCallBackService ;
  TCPSocket -> EstablishNotify = EstablishCallBackService ;
  TCPSocket -> ReceiveNotify = RecvCallBackService ;
  TCPSocket -> CloseNotify = CloseCallBackService ;
  return ( 0 ) ;
}  


static void TCPTimeService ( void * TCPInstanceEntry )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
  PtrTCPSocketDescriptionRecT Socket ;
  PtrRetransmRecT RetransmitDescr ;
   
  TCPLayerInstance = ( PtrTCPLayerInstanceRecT ) TCPInstanceEntry ;
  Socket = TCPLayerInstance -> TransmSocketTopEntry ;
  while ( Socket )
  {
    TCPLayerInstance -> InitSequenceNumber ++ ;
    RetransmitDescr = & Socket -> RetransmData ;
    if ( RetransmitDescr -> DelayTime )
    {
      RetransmitDescr -> DelayTime -- ;
      if ( ! RetransmitDescr -> DelayTime )
      {
        TCPLayerInstance -> InitSequenceNumber ++ ;
        switch ( RetransmitDescr -> TCPLastSend )
        {
          case None          :
            break ;
          case LastSend_FIN  :
            SendTCPFrame ( Socket , 0x01 | 0x10 ) ;
            RetransmitDescr -> DelayTime = 0x60 ;
            break ;
          case LastSend_SYN  :
            RetransmitDescr -> Counter ++ ;
            if ( RetransmitDescr -> Counter < 3 )
            {
              SendTCPFrame ( Socket , 0x02 ) ;
              RetransmitDescr -> DelayTime = 0x60 ;
            }  
            else
            {
              if ( Socket -> CloseNotify )
                Socket -> CloseNotify ( Socket ) ;
              DelayedFreeTCBSocket ( Socket ) ;

              return ;
            }   ;
            break ;
          case LastSend_SYNACC :
            SendTCPFrame ( Socket , 0x02 | 0x10 ) ;
            RetransmitDescr -> DelayTime = 0x60 ;
            break ;
          case LastSend_PSH  :
            RetransmitTCPWindow ( Socket ) ;
            break ;
          case LastSend_RST  :
            break ;
        }   ;
      }   ;
    }   ;
    Socket = Socket -> NextSocketLink ;
  }   ;
}  


void TCPInitInstance ( PtrTCPLayerInstanceRecT TCPLayerInstance ,
                       PtrIPLayerInstanceRecT  IPLayerInstance )
{
  USHORT Loop ;
   
  TCPLayerInstance -> ListenSocketTopEntry = ( void * ) 0 ;
  TCPLayerInstance -> TransmSocketTopEntry = ( void * ) 0 ;
  TCPLayerInstance -> LastLocalPort = 2048 ;
  TCPLayerInstance -> InitSequenceNumber = 16347 ;
  TCPLayerInstance -> IPLayerInstance = IPLayerInstance ;
  IPLayerInstance -> TCPProcessService = ProcessTCPPacked ;
  IPLayerInstance -> TCPInstanceEntry = TCPLayerInstance ;
  IPLayerInstance -> TCPTimerPoolService = TCPTimeService ;
  for ( Loop = 0 ; Loop < 8 ; Loop ++ )
    SocketStatus [ Loop ] = 0 ;
  for ( Loop = 0 ; Loop < 6 ; Loop ++ )
    WindowTableStatus [ Loop ] = 0 ;
}  


PtrIPLayerInstanceRecT GetIPInstanceTCP ( PtrTCPLayerInstanceRecT TCPLayerInstance )
{
   
  return ( TCPLayerInstance -> IPLayerInstance ) ;
}  


PtrTCPLayerInstanceRecT GetTCPInstance ( PtrTCPSocketDescriptionRecT TCPSocket )
{
   
  return ( TCPSocket -> TCPLayerInstanceLink ) ;
}  


static TCPLayerInstanceRecT LocalTCPLayerInstance ;
PtrTCPLayerInstanceRecT StandardAddTCPInstance ( PtrIPLayerInstanceRecT IPLayerInstance )
{
  PtrTCPLayerInstanceRecT TCPLayerInstance ;
   
  TCPLayerInstance = & LocalTCPLayerInstance ;
  TCPInitInstance ( TCPLayerInstance , IPLayerInstance ) ;
  return ( TCPLayerInstance ) ;
}  


