/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                      MODULE ARP Protocol Service                       **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _arp_service_
#define _arp_service_

#include "emacdriver.h"
#include "ipservice.h"

extern PtrARPTableElementRecT LocateMACForIP ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ,
                                               ULONG                  /* IPAddress */ ) ;

extern void ProcessARPPacked ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ,
                               PtrOSFrameRecT         /* Frame           */ ) ;

extern void PrepareARPRequest ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ,
                                ULONG                  /* DestIPAddress   */ ) ;

extern void DiagARPTable ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ) ;

extern void DelARPTableElement ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ,
                                 ULONG                  /* IPAddress       */ ) ;

extern void DelARPTable ( PtrIPLayerInstanceRecT /* IPLayerInstance */ ) ;

#endif
