/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2018                               **
**                                                                        **
**                          MODULE DataService                            **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2018.06.12                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _DATASERVICE_
#define _DATASERVICE_

#include "types.h"

#define DataValueSize          8

typedef UCHAR DataValueType [ DataValueSize ] ;


extern DataValueType Analog1Value ;
extern DataValueType Analog2Value ;
extern DataValueType Analog3Value ;
extern DataValueType Analog4Value ;
extern DataValueType Analog5Value ;
extern DataValueType Analog6Value ;
extern UCHAR On0Status ;
extern UCHAR On1Status ;
extern UCHAR On2Status ;
extern UCHAR On3Status ;

extern void Device01On ( void ) ;

extern void Device01Off ( void ) ;

extern void Device02On ( void ) ;

extern void Device02Off ( void ) ;

extern void SerialPool ( void ) ;

extern void InitDataService ( void ) ;

#endif
