/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                        MODULE Frame Util                               **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _frameutil_
#define _frameutil_

#include "types.h"
#include "emacdriver.h"
#include "ipservice.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void * /* StartBuffer */ ,
                                  USHORT /* BufferSize  */ ) ;

extern USHORT CalculateTCPChecksum ( ULONG  /* SourceIPAddress      */ ,
                                     ULONG  /* DestinationIPAddress */ ,
                                     void * /* StartBuffer          */ ,
                                     USHORT /* BufferSize           */ ) ;

extern USHORT CalculateUDPChecksum ( ULONG  /* SourceIPAddress      */ ,
                                     ULONG  /* DestinationIPAddress */ ,
                                     void * /* StartBuffer          */ ,
                                     USHORT /* BufferSize           */ ) ;

extern void GetByteArrayField ( void *         /* DestinationAddress */ ,
                                PtrOSFrameRecT /* Frame              */ ,
                                USHORT         /* FieldOffset        */ ,
                                USHORT         /* FieldSize          */ ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT /* Frame       */ ,
                             USHORT         /* FieldOffset */ ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT /* Frame       */ ,
                                   USHORT         /* FieldOffset */ ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT /* Frame       */ ,
                                 USHORT         /* FieldOffset */ ) ;

extern void AddByteArrayField ( PtrOSFrameRecT /* Frame         */ ,
                                void *         /* SourceAddress */ ,
                                USHORT         /* FieldSize     */ ) ;

extern void AddDuplByteField ( PtrOSFrameRecT /* Frame     */ ,
                               UCHAR          /* Data      */ ,
                               USHORT         /* FieldSize */ ) ;

extern void AddByteField ( PtrOSFrameRecT /* Frame */ ,
                           UCHAR          /* Data  */ ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT /* Frame */ ,
                                 USHORT         /* Value */ ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT /* Frame */ ,
                                ULONG          /* Value */ ) ;

extern void PutByteArrayField ( PtrOSFrameRecT /* Frame         */ ,
                                USHORT         /* FieldOffset   */ ,
                                void *         /* SourceAddress */ ,
                                USHORT         /* FieldSize     */ ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT /* Frame       */ ,
                                 USHORT         /* FieldOffset */ ,
                                 USHORT         /* Value       */ ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT /* Frame       */ ,
                                   USHORT         /* FieldOffset */ ,
                                   USHORT         /* Value       */ ) ;

extern void StartEthFrame ( PtrOSFrameRecT /* Frame          */ ,
                            UCHAR *        /* DestMACAddress */ ,
                            UCHAR *        /* SrcMACAddress  */ ,
                            USHORT         /* LenghtOrType   */ ) ;

extern void CreateIPHeader ( PtrOSFrameRecT /* Frame        */ ,
                             UCHAR          /* Protocol     */ ,
                             ULONG          /* SrcIPAddress */ ,
                             ULONG          /* DstIPAddress */ ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT /* Frame     */ ,
                                 USHORT         /* FieldSize */ ) ;

extern void ReadByteArrayField ( void *         /* DestinationAddress */ ,
                                 PtrOSFrameRecT /* Frame              */ ,
                                 USHORT         /* FieldSize          */ ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT /* Frame */ ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT /* Frame */ ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT /* Frame */ ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT * /* EtherHeader */ ,
                           PtrOSFrameRecT          /* Frame       */ ) ;

extern void GetIPHeader ( IPHeaderRecT * /* IPHeader */ ,
                          PtrOSFrameRecT /* Frame    */ ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT /* Frame */ ) ;

extern USHORT SwapBytes ( USHORT /* Data */ ) ;

#endif
