/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                     MODULE LPC2378 Serial Const                        **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.25                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _serialconst_
#define _serialconst_

#include "types.h"


#define N81Mode                             0x03
#define E82Mode                             0x1F

#define DTRAtConnect                        0x01
#define RTSAtConnect                        0x02

#define NoParityModeCode                    0x00
#define EvenParityModeCode                  0x18
#define OddParityModeCode                   0x08
#define Bits5ModeCode                       0x00
#define Bits6ModeCode                       0x01
#define Bits7ModeCode                       0x02
#define Bits8ModeCode                       0x03
#define Stop1BitCode                        0x00
#define Stop2BitCode                        0x04

#define Speed600Code                        13
#define Speed1200Code                       12
#define Speed2400Code                       11
#define Speed3600Code                       10
#define Speed4800Code                       9
#define Speed7200Code                       8
#define Speed9600Code                       7
#define Speed14400Code                      6
#define Speed19200Code                      5
#define Speed28800Code                      4
#define Speed38400Code                      3
#define Speed57600Code                      2
#define Speed115200Code                     1

#define RecvDataInterruptEnable             0x01
#define TransmDataInterruptEnable           0x02
#define LineStatusInterruptEnable           0x04
#define ModemStatusInterruptEnable          0x08

#define FIFOEnable                          0x01
#define RecvFIFOReset                       0x02
#define TrasmFIFOReset                      0x04
#define DMAModeSelect                       0x08

#define SetLoopbackMode                     0x10

#define DCDControlUARTCode                  0x80
#define RIControlUARTCode                   0x40
#define DSRControlUARTCode                  0x20
#define CTSControlUARTCode                  0x10

#define DTRControlUARTCode                  0x01
#define RTSControlUARTCode                  0x02

#define RecvBreakSignalUARTCode             0x10

#define IIR_PEND                            0x01
#define IIR_MS                              0x00
#define IIR_THRE                            0x01
#define IIR_RDA                             0x02
#define IIR_RLS                             0x03
#define IIR_CTI                             0x06

#define LSR_RDR                             0x01
#define LSR_OE                              0x02
#define LSR_PE                              0x04
#define LSR_FE                              0x08
#define LSR_BI                              0x10
#define LSR_THRE                            0x20
#define LSR_TEMT                            0x40
#define LSR_RXFE                            0x80


ULONG SerialSpeedEncoder ( UCHAR /* SpeedCode */ ) ;

#endif

