/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2018                               **
**                                                                        **
**                         MODULE I2C Service                             **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2018.06.12                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _setupservice_
#define _setupservice_

#include <LPC23xx.H>
#include "types.h"

typedef struct {
                 USHORT        Sygnature ;
                 UCHAR         MyMACAddress [ 6 ] ;
                 ULONG         MyIPAddress ;
                 ULONG         MyNetMask ;
                 ULONG         MyGWAddress ;
               } ConfigEEPROMBlockRecType ;
typedef ConfigEEPROMBlockRecType * ConfigEEPROMBlockRecPtrType ;
               
extern ConfigEEPROMBlockRecType ConfigEEPROMBlock ;
               
extern void ReadConfigBlock ( ConfigEEPROMBlockRecPtrType /* ConfigBlock */ ) ;

extern void WriteConfigBlock ( ConfigEEPROMBlockRecPtrType /* ConfigBlock */ ) ;
               
extern UCHAR GetDISPSwitch ( void ) ;

extern void ReadNewMACAddress ( ConfigEEPROMBlockRecPtrType /* ConfigBlock */ ) ;
               
extern void ReadNewIPAddress ( ConfigEEPROMBlockRecPtrType /* ConfigBlock */ ) ;
               
extern void DIPSwitchInitEnvir ( void ) ;

#endif
