/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                           MODULE Strings                               **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _strings_
#define _strings_

#include "types.h"


extern void memclear ( void * /* Buff */ ,
                       USHORT /* Size */ ) ;

extern void memcopy ( void * /* DestAdr */ ,
                      void * /* SourAdr */ ,
                      USHORT /* Size    */ ) ;

extern UCHAR Cap ( UCHAR /* Ch */ ) ;

extern void StrCpy ( UCHAR * /* DestStr */ ,
               const UCHAR * /* SourStr */ ) ;

extern USHORT StrLen ( UCHAR * /* Str */ ) ;

extern void StrDelete ( UCHAR * /* String */ ,
                        USHORT  /* ChPos  */ ,
                        USHORT  /* Lgt    */ ) ;

extern void StrNorm ( UCHAR * /* String */ ) ;

extern void StrExp ( USHORT  /* MaxSize */ ,
                     UCHAR * /* String  */ ) ;

extern void AppendCh ( UCHAR * /* String */ ,
                       UCHAR   /* AppCh  */ ) ;

extern void AppendStr ( UCHAR * /* Str    */ ,
                  const UCHAR * /* AppStr */ ) ;

extern void Append ( USHORT  /* MaxSize */ ,
                     UCHAR * /* String  */ ,
               const UCHAR * /* SubStr  */ ) ;

extern UCHAR * BegOfString ( UCHAR * /* String */ ) ;

extern void WordToHexStr ( UCHAR * /* Number    */ ,
                           USHORT  /* ConvWidth */ ,
                           UCHAR   /* EmptyCh   */ ,
                           USHORT  /* CardV     */ ) ;

extern void WordToStr ( UCHAR * /* Number    */ ,
                        USHORT  /* ConvWidth */ ,
                        UCHAR   /* EmptyCh   */ ,
                        USHORT  /* Value     */ ) ;

extern void LongToStr ( UCHAR * /* Number    */ ,
                        USHORT  /* ConvWidth */ ,
                        UCHAR   /* EmptyCh   */ ,
                        ULONG   /* Value     */ ) ;

extern void IPToString ( UCHAR * /* ConvBuff  */ ,
                         ULONG   /* IPAddress */ ) ;

extern UCHAR Digit ( UCHAR /* Character */ ) ;

extern UCHAR StrToCard ( UCHAR *  /* String */ ,
                         USHORT * /* Result */ ) ;

extern UCHAR StrToLCard ( UCHAR * /* String */ ,
                          ULONG * /* Result */ ) ;

extern UCHAR CompareString ( UCHAR * /* String1 */ ,
                             UCHAR * /* String2 */ ,
                             USHORT  /* Size    */ ) ;

extern UCHAR StrToIP ( UCHAR * /* IPString */ ,
                       ULONG * /* IPBinary */ ) ;

#endif
