/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                           MODULE System                                **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/
 
#ifndef _system_
#define _system_

#include "LPC2300Config.h"

// PLL setup const
#define FOSC         ( 12000000UL )        // Master Oscillator Freq.
#define PLL_MUL      ( 12 )              // PLL Multiplier
#define PLL_DIV      ( 1 )               // PLL Divider
#define CCLK_DIV     ( 5 )               // PLL out -> CPU clock divider
#define CCLK         ( FCCO / CCLK_DIV ) // CPU Clock Freq.

// Pheripheral Bus Speed Divider
#define PBSD         1
#define PCLK         ( CCLK / PBSD )     // Pheripheal Bus Clock Freq.

#if ( ( FOSC < 10000000 ) || (FOSC > 25000000 ) )
#error Fosc out of range (10MHz-25MHz)
#error correct and recompile
#endif

#if ( ( CCLK < 10000000 ) || ( CCLK > 72000000 ) )
#error cclk out of range (10MHz-72MHz)
#error correct PLL_MUL and recompile
#endif

#if ( ( FCCO < 275000000) || (FCCO > 550000000 ) )
#error Fcco out of range (275MHz-550MHz)
#error internal algorithm error
#endif

#if ( ( PBSD != 1 ) && ( PBSD != 2 ) && ( PBSD != 4 ) )
#error Pheripheal Bus Speed Divider (PBSD) illegal value (1, 2, or 4)
#endif

#ifdef LowLevelInitFlag
extern void ConfigPLL ( void ) ;

extern void LowLevelInit ( void ) ;
#endif

extern void SysInit ( void ) ;

#define NOP() __asm ( "nop" )

#endif
