/*
****************************************************************************
****************************************************************************
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                                                                        **
**                           BIALYSTOK 2007                               **
**                                                                        **
**                           MODULE SysTime                               **
**                                                                        **
**                     Mikrokontroler ARM: LPC2378                        **
**                                                                        **
**                     Wersja z dnia : 2007.03.22                         **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/

#ifndef _systime_
#define _systime_

#include "types.h"

typedef void ( * TimeServiceProcT ) ( void * /* CallParam */ ) ;

typedef struct {
                 ULONG             BellTime ;
                 void *            CallParam ;
                 TimeServiceProcT  CallService ;
               } TimeQueueRecT ;
typedef TimeQueueRecT * PtrTimeQueueRecT ;


extern void SysTimeEnevtService ( void ) ;

extern PtrTimeQueueRecT AttachTimer ( ULONG             /* RelativeAlarmTime */ ,
                                      TimeServiceProcT  /* CallService       */ ,
                                      void *            /* CallParam         */ ) ;

extern void DetachTimer ( PtrTimeQueueRecT /* TimeQueueElement */ ) ;

void SysTimerPool ( void ) ;

void InitSysTime ( void ) ;

#endif
